<!-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.publisher.PublisherConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<orion:script context="/core" src="/majic.js"/>

<orion:script context="/core" src="/yui/connection/connection-min.js"/>
<jsp:include page="/common/includejQuery.jsp" />
<orion:style context="/SOLIDCORE_META" url="/css/override.css" />

<orion:message key="scor.publisher.issToHeader" var="issToHeader" escape="HTML"/>
<orion:message key="scor.publisher.issByHeader" var="issByHeader" escape="HTML"/>
<orion:message key="scor.publisher.expDateHeader" var="expDateHeader" escape="HTML"/>
<orion:message key="scor.publisher.frdNameHeader" var="frdNameHeader" escape="HTML"/>
<orion:message key="scor.publisher.updaterHeader" var="updaterHeader" escape="HTML"/>
<orion:message key="scor.publisher.updaterTagHeader" var="updaterTagHeader" escape="HTML"/>
<orion:message key="scor.publisher.findLbl" var="findLbl" escape="HTML"/>
<orion:message key="scor.publisher.findBtnTxt" var="findBtnTxt"  escape="none"/>
<orion:message key="scor.publisher.chkBoxHeader" var="chkBoxHeader" escape="HTML"/>
<orion:message key="scor.publisher.add.title" var="addTitle" escape="javascript"/>
<orion:message key="scor.publisher.add.btnTxt" var="addBtnTxt" escape="javascript"/>
<orion:message key="scor.publisher.remove.btnTxt" var="remBtnTxt" escape="javascript"/>
<orion:message key="scor.publisher.pubHelpTxt" var="pubHelpTxt" escape="HTML"/>
<orion:message key="scor.publisher.emptySelection" var="empSel" escape="javascript"/>
<orion:message key="scor.publisher.allDuplicates" var="dupMsg" escape="javascript"/>
<orion:message key="scor.publisher.duplicates.title" var="dupTitle" escape="javascript"/>
<orion:message key="scor.publisher.duplicates.info" var="dupInfo" escape="javascript"/>
<orion:message key="scor.publisher.emptyUpdaterLabel" var="empUpdaterLabel" escape="javascript"/>
<orion:message key="scor.publisher.issToHeader" var="issToHeaderJs" escape="javascript"/>
<orion:message key="scor.publisher.issByHeader" var="issByHeaderJs" escape="javascript"/>
<orion:message key="scor.publisher.frdNameHeader" var="frdNameHeaderJs" escape="javascript"/>
<orion:message key="scor.policy.awl.button.edit" var="editBtnTxt" escape="javascript"/>

<orion:message key="scor.publisher.updaterWarnMsg" var="updaterWarnMsg" escape="javascript"/>
<orion:message key="scor.publisher.updaterCheckBoxMsg" var="updaterChkBoxMsg" escape="none"/>
<orion:message key="scor.publisher.updaterTagLabel" var="updaterLabel" escape="HTML"/>
<orion:message key="scor.publisher.updaterHelpText" var="updaterHelpText" escape="HTML"/>
<orion:message key="scor.publisher.edit.title" var="editTagTitle" escape="javascript"/>
<orion:message key="scor.awl.publisher.no.editPermission.msg" var="noEditPermissionMsg" escape="HTML"/>

<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupPublisherRules" authToken = "isAuthorizedToViewPublisherRules"/>

<orion:box id="PublisherTab" >
	<div id="publishersErrorDivId" class="errorRuleTab">${noEditPermissionMsg}</div>
    <table id="publisherTable" cellspacing="0" cellpadding="0" width="98%">
        <%@ include file="../AdjustOtherTabs.jsp" %>
        <tr>
            <td class="orionSummaryColumn">
                <!-- width is 98% of the width of the list widget so its 882px-->
                <table cellspacing='3' cellpadding='0' width='882px'>
                    <tr>
                        <td width="20%"><b>${issToHeader}</b></td>
                        <td width="25%"><b>${issByHeader}</b></td>
                        <td width="20%"><b>${expDateHeader}</b></td>
                        <td width="10%"><b>${frdNameHeader}</b></td>
                        <td width="10%"><b>${updaterHeader}</b></td>
                        <td width="15%"><b>${updaterTagHeader}</b></td>

                        <!-- more attributes add here -->
                    </tr>
                </table>
                <orion:box id="publisherList" height="auto" width="620"/>
            </td>
        </tr>
    </table>

    <div id="publisher_list_row_template" style="display:none;">
        <table cellspacing='0' cellpadding='0' width='882' style="table-layout: fixed" >
            <tr>
                <td width='20%' class="scorWordWrap">
                    @IssuedTo
                </td>
                <td width='25%' class="scorWordWrap">
                    @IssuedBy
                </td>
                <td width='20%' class="scorWordWrap">
                    @ExpDate
                </td>
                <td width='10%' class="scorWordWrap">
                    @FrdName
                </td>
                <td width='10%'>
                    @updater
                </td>
                <td width='15%' class="scorWordWrap">
                    @Tag
                </td>

                <td style="visibility:hidden;background:#ff0000;">
                    @id
                </td>
                <!-- more attributes add here -->
            </tr>
        </table>
    </div>

	 <!--  Updater tag template -->
	 <div id="updater_tag_template" style="display:none;">
	 <table width="100%">
            <tr>
                <td colspan="2">
                    <orion:checkbox id="updaterChkBox" text="${updaterChkBoxMsg}"
                    onclick="setupUpdater(this)"/>
                </td>
            </tr>
            <tr>
                <td>
                    ${updaterLabel}
                </td>
                <td>
                    <orion:textbox id="updaterBox" value="" disabled="true" />
                </td>
            </tr>
            <tr>
                <td colspan="2" style="padding:5px;">
                    ${updaterHelpText}
                </td>
            </tr>

        </table>
	 </div>

	 <div id="scorPubsHiddenFieldsDiv">
          <input type="hidden" id="IssuedTo"/>
          <input type="hidden" id="IssuedBy" />
          <input type="hidden" id="ExpDate" />
          <input type="hidden" id="FrdName" />
          <input type="hidden" id="updater" />
          <input type="hidden" id="Tag" />
          <input type="hidden" id="id" />
      </div>
      
    <div id="publisher_header_template" style="display:none;">
    <table cellspacing='3' cellpadding='0' width='95%'>
        <tr>
            <td width="20%"><b>${chkBoxHeader}</b></td>
            <td width="25%"><b>${issToHeader}</b></td>
            <td width="25%"><b>${issByHeader}</b></td>
            <td width="30%"><b>${expDateHeader}</b></td>
            <td style="visibility:hidden;background:#ff0000;"></td>
        </tr>
    </table>
</div>

</orion:box>



<script type="text/javascript">
<c:if test = "${isAuthorizedToViewPublisherRules == false}">
	$j('#PublisherTab').hide();
</c:if>
//variable to hold the <div> where publisher table needs to be placed.
var publisherHolder=null;
//We need to maintain data for alreaday added certificates to the policy/group
var certsInPubList=null;

//Returns the last index where value is found
scor.utils.arrayContains = function(arr,value) {
	  var i = arr.length;
	  while (i--) {
	    if (arr[i] === value) {
	      return i;
	    }
	  }
	  return -1;
}

//Concatenate all nonempty array elements
_joinArrayElements=function (arr,separator){
	var str="";
	for(var i = 0; i < arr.length; i++){
		if(str !== ""){
			str = str+separator;
		}
		var elem = arr[i];
		if(elem !== undefined && elem!== null){
			elem = OrionCore.trim(String(elem));
            if(elem!==""){
		        str = str+elem;
             }
		}
	}
	return str;
}

_diffArrays = function (array1, array2) {
      if (array2.length === 0){
        return array1;
      }
      var array1String = ":" + _joinArrayElements(array1,"::") + ":";
      var array2String = ":" +  _joinArrayElements(array2,":|:") + ":";
	  // all elements in the array2 are empty
      if(array2String === "::"){
      	return array1;
      }
      var reg = new RegExp("(" + array2String + ")","gi");
      //Replace all the elements from array2. Also remove all the leading & trailing :
      var strDiff = array1String.replace(reg,"").replace(/^:/,"").replace(/:$/,"");
	  // For identical arrays
      if(strDiff === "") {
          return [];
      }
      var arrDiff = strDiff.split("::");
      return arrDiff;
}

function fnDeleteCallbck(deletedRow){
	if(deletedRow){
		var deletedPub = this.list[deletedRow.id];
		var deletedPubID=deletedPub.id;
		var idx=scor.utils.arrayContains(certsInPubList,deletedPubID);
		//If ID is present in certsInPubList, Remove it
		if(idx !== -1){
			certsInPubList.splice(idx,1);
		}
	}
	myEpoEnableApplyButton();
}

var publishList = new majic.ListWidget({
    container: "publisherList",
    width: "900px",
    height: "320px",
    addCallback: fnAddPublisherCallback,
    removeCallback: fnDeleteCallbck,
    buttons: {
        'insert': '${addBtnTxt}',
        'edit': '${editBtnTxt}',
        'remove': '${remBtnTxt}'
    },
    displayText: $('publisher_list_row_template').innerHTML,
    formatCallback: listWidgetformatCallback
});

function insertPublisherRow(publisher){
    var newObj = {"IssuedTo" : publisher.issuedTo,
        "IssuedBy" : publisher.issuedBy,
        "ExpDate":publisher.dateString,
        "FrdName":publisher.friendlyName,
        "updater" : publisher.updater,
        "Tag" : publisher.updaterTag,
        "id":publisher.id}
    publishList.insert(newObj) ;
	var newObjID=newObj.id;
	var idx = scor.utils.arrayContains(certsInPubList,newObjID);
	//ID is not present in certsInPubList
	if(idx === -1){
    	certsInPubList.push(newObjID);
    }
}

function fnAddPublisherCallback()
{
    OrionCore.setDialogBoxTitle('${addTitle}');
    OrionForm.revalidate();
    epoEnableApplyButton();
}

var insertButton = publishList.buttonElements[0];
insertButton.onclick = handleMultiAdd1;

var editButton = publishList.buttonElements[1];
editButton.onclick = handleEdit;

function handleEdit(){
	 if(publishList.selrow){
		//Setup dialog box
	    OrionCore.showDialogBox(true, $('updater_tag_template').innerHTML,OrionCore.DIALOG_OK_CANCEL);
	    OrionCore.dialogBoxOkHandler=assignTag;
	    OrionCore.setDialogBoxTitle('${editTagTitle}');
	 	// Setup current values for updater tag
	    var selectedRow = publishList.list[publishList.selrow.id];
	    var updaterVal = selectedRow.updater;
	    var tagVal = selectedRow.Tag;
	    if("Yes" === updaterVal){
			var checkBox = scorFindElementById(scorGetDialogBox(),'input','updaterChkBox');
			checkBox.checked=true;
			var tagBox=scorFindElementById(scorGetDialogBox(),'input','updaterBox');
			tagBox.value=tagVal;
			OrionCore.setEnabled(tagBox,true);
	    }
	    epoEnableApplyButton();
	 }
}


var assignTag = function (){
	var chkbox = scor.utils.GetElementFromDialogBox("updaterChkBox","input");
    var isUpdater="No";
    var updaterLabel = scor.utils.GetElementFromDialogBox("updaterBox","input");
    if(chkbox.checked){
       isUpdater="Yes";
       if(scor.utils.isNullOrEmpty(updaterLabel)){
       		alert('${empUpdaterLabel}');
       		return false;
       }
    }
	//modify values for updater tag
   var selectedPubObj = publishList.list[publishList.selrow.id];
   selectedPubObj.updater=isUpdater;
   selectedPubObj.Tag=updaterLabel.value;
   publishList.insert(selectedPubObj,true) ;
};

function setupUpdater(updrChkBox) {
    if(updrChkBox.checked) {
       alert('${updaterWarnMsg}');
        OrionCore.setEnabledById("updaterBox", true);
    } else {
    	var updaterElem = scor.utils.GetElementFromDialogBox("updaterBox","input");
    	updaterElem.value='';
        OrionCore.setEnabledById("updaterBox", false);
    }
}

function setDialogSize(){
    scorSetDialogSize(500,850);
}

function handleMultiAdd1(){
	OrionCore.setDialogBoxTitle('${addTitle}');
    OrionCore.showAsyncDialogBox( true, "<%=URLConstants.PUBLIHSER_DIALOG_URL%>",null,setDialogSize );
	OrionCore.dialogBoxOkHandler = scorFindCertDialogHandler;
	epoEnableApplyButton();
}

 function scorFindCertDialogHandler(){
    var selectedIds=ScorDialogTable.getSelectedUIDs('publisherTableD');
    if(selectedIds.length === 0){
	alert('${empSel}');
		return false;
    }
    var toBeAddedIds=_diffArrays(selectedIds,certsInPubList).join(",");
 	// Current selction is already part of added selection.
    if(toBeAddedIds.length===0){
        alert('${dupMsg}');
  		return;
    }
    var chkbox = scor.utils.GetElementFromDialogBox("pubAddAsUpdater","input");
    var isUpdater="No";
    var updaterLabel = scor.utils.GetElementFromDialogBox("pubUpdaterLabel","input");
    if(chkbox.checked){
       isUpdater="Yes";
       if(scor.utils.isNullOrEmpty(updaterLabel)){
       		alert('${empUpdaterLabel}');
       		return false;
       }
    }

	var selectedIdsString = selectedIds.join(",");
	var certsInPubListString;
	if(certsInPubList === null || certsInPubList.length === 0 ){
		certsInPubListString="";
	}else{
		certsInPubListString=certsInPubList.join(",");
	}

     scor.actions.doAsyncAction("<%=URLConstants.PUBLIHSER_SEARCH_RESULTS%>",
             ['<%=PublisherConstants.PUBLISHER_ID_CRITERIA%>',selectedIdsString,'<%=PublisherConstants.PUBLISHER_ID_EXISTING%>',certsInPubListString,
             '<%=PublisherConstants.PUBLISHER_ID_UPDATER%>',isUpdater,
             '<%=PublisherConstants.PUBLISHER_ID_UPDATER_LABEL%>',updaterLabel.value],
             scorLoadPublisherSuccess);
}
	//Take care of duplicates
  function scorLoadPublisherSuccess(awlPubVO){
	var pubList;
	var duplicates=[];
	//Add search results
	pubList = awlPubVO ? awlPubVO.publishers : {};
    for(var i=0; i < pubList.length; i++)
    {
		var pubItem = pubList[i];
        //For duplicate handling
       if(pubItem.isAdded === true){
    	   duplicates.push(pubItem);
       }else{
    	   insertPublisherRow(pubItem);
        }
    }
    showDuplicates(duplicates);
  }

  function showDuplicates(duplicates){
	  if(duplicates.length!==0){
		  var headerRow='<tr><td width="30%"><b>${issToHeaderJs}</b></td>'+
			  				'<td width="40%"><b>${issByHeaderJs}</b></td>'+
			  				'<td width="30%"><b>${frdNameHeaderJs}</b></td></tr>';
		  var duplicateMsg='<pre><b>${dupInfo}</b></pre>';
		  var tableData='';
		  for(var index=0;index < duplicates.length; index++){
			var dup = duplicates[index];
			tableData += '<tr><td width="30%">'+dup.issuedTo+
						 '</td><td width="40%">'+dup.issuedBy+
						 '</td><td width="30%">'+dup.friendlyName+'</td></tr>';
		  }
		  var html = duplicateMsg+'<table border="1" cellspacing="0" cellpadding="2"><tbody>'+
		  			 headerRow+tableData+'</table></tbody>';
		  OrionCore.setDialogBoxTitle('${dupTitle}');
		  OrionCore.showDialogBox(true,html,OrionCore.DIALOG_OK);
		}
  }

function populatePublishers(publishers)
{
    scor.utils.clearMagicListWidget(publishList);
    //Re-initialize
    certsInPubList = new Array();
    publishers = publishers ? publishers : {};
    for(var i=0; i < publishers.length; i++)
    {
        //add row to magic list and updates certsInPubList
        insertPublisherRow(publishers[i]);
    }
}


function getPublishers()
{
    var vo = [];
    var rows = publishList.getRows();
    for (var rowKey in rows)
    {
        var row = rows[rowKey];
        if (row != null && row != undefined)
        {
            vo.push( {"issuedTo": scor.utils.trim(row['IssuedTo']),
                "issuedBy": scor.utils.trim(row['IssuedBy']),
                "dateString": scor.utils.trim(row['ExpDate']),
                "friendlyName":scor.utils.trim(row['FrdName']),
                "id": scor.utils.trim(row['id']),
                "updater": scor.utils.trim(row['updater']),
                "updaterTag": scor.utils.trim(row['Tag'])});

        }
    }
    return vo;
}

function enablePublishList(enable){
    publishList.setEnabled(enable);
}

</script>


