<!-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<orion:script context="/core" src="/majic.js"/>
<orion:style context="/SOLIDCORE_META" url="/css/override.css" />

<orion:message key="scor.policy.awl.button.add" var="awlButtonAdd" escape="javascript"/>
<orion:message key="scor.policy.awl.button.edit" var="awlButtonEdit" escape="javascript"/>
<orion:message key="scor.policy.awl.button.remove" var="awlButtonRemove" escape="javascript"/>
<orion:message key="scor.awl.trustedDirectory.add.heading.label" var='addTrustedDirectoryLabel' escape="HTML"/>
<orion:message key="scor.awl.trustedDirectory.add.updaterChkBox.label" var='updaterChkBoxLabelHtm' escape="none"/>
<orion:message key="scor.awl.trustedDirectory.listWidget.heading.path" var='listHeadingPath' escape="HTML"/>
<orion:message key="scor.awl.trustedDirectory.listWidget.heading.action" var='listHeadingAction' escape="HTML"/>
<orion:message key="scor.awl.trustedDirectory.listWidget.heading.updater" var='listHeadingUpdater' escape="HTML"/>
<orion:message key="scor.awl.trustedDirectory.add.textbox.path" var='addDialogPath' escape="none"/>
<orion:message key="scor.awl.trustedDirectory.add.label.include" var='addDialogInclude' escape="none"/>
<orion:message key="scor.awl.trustedDirectory.add.label.exclude" var='addDialogExclude' escape="none"/>
<orion:message key="scor.awl.trustedDirectory.add.heading" var='addDialogHeading' escape="javascript"/>
<orion:message key="scor.awl.trustedDirectory.edit.heading" var='editDialogHeading' escape="javascript"/>
<orion:message key="scor.trustedDirectory.duplicate.label" var="duplicateLabel" escape="HTML"/>
<orion:message key="scor.awl.trustedDirectory.no.editPermission.msg" var="noEditPermissionMsg" escape="HTML"/>

<c:set var="WIN_OS" scope="request" value="<%=com.mcafee.scor.rulegroup.RuleGroupConstants.RULE_GROUP_OS.WIN.getValue()%>"/>
<c:set var="UNIX_OS" scope="request" value="<%=com.mcafee.scor.rulegroup.RuleGroupConstants.RULE_GROUP_OS.UNIX.getValue()%>"/>

<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupTrustedDirRules" authToken = "isAuthorizedToViewTrustedDirRules"/>

<orion:box id="trustedDirectoriesTabId" >
<div id="trustedDirectoriesErrorDivId" class="errorRuleTab">${noEditPermissionMsg}</div>
<table id="trustedDirectory" cellspacing="0" cellpadding="0" width="98%">
    <%@ include file="../AdjustOtherTabs.jsp"%>
    <tr>
        <td class="orionSummaryColumn">
            <!-- width is 98% of the width of the list widget so its 882px-->
            <table cellspacing='3' cellpadding='0' width='882px'>
                <tr>
                    <td width="70%"><b>${listHeadingPath}</b></td>
                    <td width="20%"><b>${listHeadingAction}</b></td>

                    <c:if test="${param.osType == WIN_OS}">
                        <td width="10%"><b>${listHeadingUpdater}</b></td>
                    </c:if>
                    <!-- more attributes add here -->
                </tr>
            </table>
            <orion:box id="trustedDirectoriesList" height="auto" width="620"/>
        </td>
    </tr>
</table>

<div id="directory_list_row_template" style="display:none;">
    <table cellspacing='0' cellpadding='0' width='98%' style="table-layout: fixed" >
        <tr>
            <td width='70%' class="scorWordWrap">
                @path
            </td>
            <td width='20%'>
                @includeExcludeAction
            </td>
            <c:if test="${param.osType == WIN_OS}">
                <td width='10%'>
                    @updater
                </td>
            </c:if>
            <!-- more attributes add here -->
        </tr>
    </table>
</div>

<div id="directory_filter_editor_template" style="display:none;">
    ${addTrustedDirectoryLabel}
    <table width="100%">
        <tr>
        <orion:hbox>
            <td width="15%">${addDialogPath}:</td>
            <td width="85%">
                <orion:textbox id="path" required="true" maxlength="255"/>
            </td>
        </orion:hbox>
        </tr>
        <tr>
            <td width="15%"></td>
            <td width="85%">
                <orion:hbox>
                    <%--These two items represent the radio buttons in the page. The first one (Include) is checked by default--%>
                    <orion:radiobutton name="includeExcludeAction" id="includeAction" text="${addDialogInclude}" value="Include" checked="true" onclick="directoryClickIncludeRadio(this)"/>
                    <orion:radiobutton name="includeExcludeAction" id="ExcludeAction" text="${addDialogExclude}" value="Exclude" onclick="directoryClickExcludeRadio(this)"/>
                    <%--This input is to accomplish POST action. It matches the default radio button value in case the selection does not change--%>
                    <input type="hidden" id="includeExcludeAction" value="Include"/>
                </orion:hbox>
            </td>
        </tr>
        <tr>
            <td width="15%"></td>
            <td width="85%">
                <c:if test="${param.osType == WIN_OS}">
                    <orion:checkbox name="updaterChkBox" id="updaterChkBox" text="${updaterChkBoxLabelHtm}" value="false" onClick="scorTrusteddirectoryChkBoxClkHandler(this,'updater');"/>
                    <input type="hidden" id="updater" name="updater" value="false"/>
                </c:if>
            </td>
        </tr>
        <!-- more attributes add here -->
    </table>
    <div id="error_include" style="display:none;color:red;">
        *&nbsp;${duplicateLabel}
    </div>
    <div id="scor_warningDiv" class="scorWarning" style="display:none;"></div>
</div>
</orion:box>

<script type="text/javascript">
<c:if test = "${isAuthorizedToViewTrustedDirRules == false}">
    $j('#trustedDirectoriesTabId').hide();
</c:if>

function scorTrusteddirectoryChkBoxClkHandler(box,id){
    var updater = scor.utils.GetElementFromDialogBox(id,'input');
    if(box.checked){
        updater.value = 'true';
    }else{
        updater.value = 'false';
    }
}

function directoryClickIncludeRadio(include){
    clearErrorDiv();
    $('includeExcludeAction').value = scor.utils.getValuesOfSelectedRadioFromDialogBox('includeExcludeAction');
	<c:if test='${param.osType == WIN_OS}'>
        OrionCore.setEnabledById( 'updaterChkBox', true );
	</c:if>
}

function directoryClickExcludeRadio(exclude){
    clearErrorDiv();
    $('includeExcludeAction').value = scor.utils.getValuesOfSelectedRadioFromDialogBox('includeExcludeAction');
	<c:if test='${param.osType == WIN_OS}'>
    	$('updaterChkBox').checked = false;
    	$('updater').value = 'false'
    	OrionCore.setEnabledById( 'updaterChkBox', false );
	</c:if>
}

function clearErrorDiv(){
    var errorDiv = scor.utils.GetElementFromDialogBox('error_include','div');
    errorDiv.innerHTML = '';
}

var trustedDirectoriesList = new majic.ListWidget({
    container: "trustedDirectoriesList",
    width: "900px",
    height: "320px",
    addCallback: directoryAddCallback,
    editCallback: directoryEditCallback,
    removeCallback: myEpoEnableApplyButton,
    buttons: {
        'add': '${awlButtonAdd}',
        'edit': '${awlButtonEdit}',
        'remove': '${awlButtonRemove}'
    },
    content: $('directory_filter_editor_template').innerHTML,
    displayText: $('directory_list_row_template').innerHTML,
    formatCallback: listWidgetformatCallback
});

function getTrustedDirectories()
{
    var vo = [];
    var rows = trustedDirectoriesList.getRows();
    for (var rowKey in rows)
    {
        var row = rows[rowKey];
        if (row != null && row != undefined)
        {
            vo.push({"path": OrionCore.trim(row['path']),
                "action": OrionCore.trim(row['includeExcludeAction']),
                "updater": OrionCore.trim(row['updater'] == "true" ? "true" : "false")});
        }
    }
    return vo;
}

function populateTrustedDirectories(trustedDirectories)
{
    scor.utils.clearMagicListWidget(trustedDirectoriesList);
    trustedDirectories = trustedDirectories ? trustedDirectories : {};
    for(var i=0; i < trustedDirectories.length; i++)
    {
        var newObj = {"path" : trustedDirectories[i].path,
            "includeExcludeAction" : trustedDirectories[i].action,
            "updater" : (trustedDirectories[i].updater == "true" ? "true" : "false")
        }
        trustedDirectoriesList.insert(newObj) ;
    }
}

function directoryAddCallback()  {
    directoryCommonCallBk('${addDialogHeading}');
}

function directoryEditCallback() {
    var selectedRow = trustedDirectoriesList.selrow;
    if(typeof selectedRow === 'undefined' || selectedRow === null){
        return;
    }
    directoryCommonCallBk('${editDialogHeading}');
    var includeExcludeRadio = $('includeExcludeAction').value;
    if(includeExcludeRadio === 'Exclude') {
        $j('#includeAction').attr('checked', false);
        $j('#ExcludeAction').attr('checked', true);	
    }
	<c:if test='${param.osType == WIN_OS}'>
       	if(includeExcludeRadio === 'Exclude') {
           	OrionCore.setEnabledById( 'updaterChkBox', false );
	    }
    	var updaterVar = $('updater').value;
    	if(updaterVar == 'true'){
	        check('updaterChkBox');
    	} else{
        	uncheck('updaterChkBox');
    	}
	</c:if>
}

function directoryCommonCallBk(title){
    scorSetDialogSize(351,701);
    OrionCore.setDialogBoxTitle(title);
    var directoryPath = scor.utils.GetElementFromDialogBox('path','input');
    OrionEvent.registerHandler(directoryPath,directoryPathValidator, null, "keyup", false);
    OrionForm.revalidate();
    var existingOkHanlder = OrionCore.dialogBoxOkHandler;
    OrionCore.dialogBoxOkHandler = function () {
        var validationObj = directoryPathValidator();
        if(validationObj.isInvalid()){
            return false;
        }
        OrionEvent.unregisterHandler(directoryPath, directoryPathValidator,"keyup", false );
        existingOkHanlder();
        myEpoEnableApplyButton();
    };
}

function directoryPathValidator(){
    var directoryPath = scor.utils.GetElementFromDialogBox('path','input');
    var os='${orion:escapeJavaScriptString(param.osType)}';
    var validationObj = scor.validation.emptyValidater(directoryPath);
    if('${orion:escapeJavaScriptString(param.osType)}' === 'WIN'){
        if(validationObj.getIsValid()){
            validationObj = scor.validation.IsValidDomainUserPath(directoryPath.value, os);
            scor.common.validation.showWarningOnStarCharactor(validationObj,directoryPath.value, os); // show warning on entering star characters
        }
    }
    scor.validation.processValidationResult(validationObj,directoryPath);
    return validationObj;
}

function enableTrustedDirectoriesList(enable){
    trustedDirectoriesList.setEnabled(enable);
}
</script>
