<!-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.installer.InstallerConstants" %>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.INSTALLERS%>");
</script>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<orion:script context="/SOLIDCORE_META" src="/jsFiles/vos/awlvos.js"/>
<orion:script context="/core" src="/majic.js"/>

<jsp:include page="/common/includejQuery.jsp"/>

<orion:message key="scor.apps.table.title" var="appTableTtl"  escape="none"/>
<orion:message key="scor.policy.awl.app.prodName" var="appProdName"  escape="none"/>
<orion:message key="scor.policy.awl.app.vendor" var="appVendor" escape="none"/>
<orion:message key="scor.policy.awl.app.filterTitleBar" var="appFilterTitle" escape="none"/>
<orion:message key="scor.policy.awl.app.findBtnTxt" var="findBtnTxt" escape="none"/>
<orion:message key="scor.policy.awl.app.findLbl" var="findLbl" />
<orion:message key="scor.app.usageGrp" var="usageGrp" escape="javascript"/>
<orion:message key="scor.app.usagePolicy" var="usagePolicy" escape="javascript"/>
<orion:message key="scor.app.checkUsage.title" var="checkUsageTitle" escape="javascript"/>
<orion:message key="scor.app.checkUsage.failure" var="checkUsageError" escape="javascript"/>
<orion:message key="scor.app.checkUsage.nousage" var="noUsage" escape="javascript"/>
<orion:message key="scor.error.dialogBox.title" var="scorErrorTitle" escape="javascript"/>
<orion:message key="scor.publisher.search.lbl" var="searchLbl" escape="HTML"/>


<orion:vbox>
	<!-- Search Tab -->
	    <orion:box height="83">
	        <orion:titlebar text="${appFilterTitle}">
	        </orion:titlebar>
	        <table width="100%" height="70%" cellspacing="1px" cellpadding="1px" style="background-color: rgb(235, 235, 235); width: 100%;">
	             <tr>
             	  	<td>${searchLbl}
						<orion:radiobutton id="appProdName_label" name="appSearchType" value="appNameCrit"
						text="${appProdName}" disabled="false" checked="true" onclick="setAppSearchCriteria('APP_NAME')"/>
						<orion:radiobutton id="appVendor_label" name="appSearchType" value="vendorCrit"
						 text="${appVendor}" disabled="false" checked="false" onclick="setAppSearchCriteria('VENDOR')"/>
						<input type="hidden" id="appSearchCriteria" value="APP_NAME"/>
				   </td>
	             </tr>
	             <tr>
					<td>
						<orion:textbox id="app_search_str"/>
		                               &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		                <orion:button id="search_button" text="${findBtnTxt}" disabled="false" onclick="getAppData()"/>
	                </td>
				</tr>
	        </table>

	    </orion:box>
	<!-- Application Table -->
        <orion:table2 id="appsTable" 
        				titleText="${appTableTtl}"
        				cellRendererAttr="<%=InstallerConstants.APPS_CELL_RENDR_ATTR%>"
        				datasourceAttr="<%=InstallerConstants.APPS_DATASOURCE_ATTR%>" 
        				sortColumn="appName" 
        				sortOrder="0"
        				showCheckboxColumn="true" 
        				enableDrilldown="true" 
        				allowExport="true"
        				registeredTypeUID="SCOR_APP_ACTIONS"
        				columnWidths="200,100,100,100,250,250"
        				properties="appName,binaryName,version,vendor,checksum,checksum256"/>
</orion:vbox>

<script type="text/javascript">

	var scor = scor || {};
	scor.installer = scor.installer || {};

	scor.installer.page = (function(){
    	var tab ;
    	return {
        	getTable : function(){
    				return tab;
    			},
			setTable : function(table){
    				tab = table;
    			}
        	}
    	})();

	showAssignements = function(response){		
		var resultObj = JSON.parse(response);
		var returnCode = resultObj.returnCode.code;		
		if(returnCode===0){
			OrionCore.setDialogBoxTitle('${checkUsageTitle}');
			var usageResult = resultObj.result;
			var ruleGrps = usageResult.ruleGroups;
			var policy = usageResult.policyNames;
			if(ruleGrps.length === 0 && policy.length ===0){
				showMsg('${noUsage}',false);
				return;
			}
			var ruleUsage="";
			var policyUsage="";
			if(ruleGrps.length !== 0){
				ruleUsage = '${usageGrp} : '+OrionCore.escapeHtml(ruleGrps.join(","));
			}
			if(policy.length !== 0){
				policyUsage = '${usagePolicy} : '+OrionCore.escapeHtml(policy.join(","));
			}
			var msg = "<pre>" + ruleUsage +'\n'+policyUsage +"</pre>";
			showMsg(msg,false);
		}else{
			showMsg('${checkUsageError}',true);
		}
	}

	function showMsg(msg,isError){
	 	if(isError === true){
	 		OrionCore.setDialogBoxTitle('${scorErrorTitle}');
	 	}
	 	OrionCore.showDialogBox(true,msg,OrionCore.DIALOG_OK);
	 	OrionCore.dialogBoxOkHandler=function(){
			refreshTable();
		}
	}
    function refreshTable(){
    	scor.installer.page.getTable().refresh();
    }

    function setAppSearchCriteria(type){
		$("appSearchCriteria").value=type;
	}

    function getAppData(){
        var searchCrit = document.getElementById("appSearchCriteria").value;
        var searchStr = document.getElementById("app_search_str").value;
	    var filter =  searchCrit+":"+searchStr;
	  //setFilter internally reload the table data. Hence no need to call refresh on table.
	    scor.installer.page.getTable().setFilter(filter);
    }

    function _initApp(){
    	scor.installer.page.setTable(MFSTable.get("appsTable"));
        //search box
	    OrionForm.markInputExempt('app_search_str');
	    //radio button
        OrionForm.markInputExempt('appProdName_label');
        OrionForm.markInputExempt('appVendor_label');
	    $j('#app_search_str').keypress(function(e) {
	    	var code = e.keyCode ? e.keyCode : e.which;
	    	if (code === 13) {
	    		getAppData();
	    	}
	    });
	 }

	 OrionCore.addLoadHandler(_initApp);
</script>










