<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<orion:message key="scor.task.ob" var="obModeLabel" />
<orion:message key="scor.task.ob.help.text" var="obModeHelpText" />
<orion:message key="scor.task.ob.start" var="obModeStartLabel" escape="none"/>
<orion:message key="scor.task.ob.end" var="obModeEndLabel" escape="none" />
<orion:message key="scor.task.ob.end.solidifier.enable" var="enableSsOnObModeEndLabel" escape="none" />
<orion:message key="scor.task.ob.end.solidifier.disable" var="disableSsOnObModeEndLabel" escape="none" />
<orion:message key="scor.task.ob.end.inventory.update.label" var="updateInvOnObModeEndLabel" />
<orion:message key="scor.task.ob.end.inventory.update.desc" var="updateInvOnObModeEndDesc" escape="none" />

<orion:message key="scor.task.ob.workflowID" var="labelWorkflowID"/>
<orion:message key="scor.task.ob.comment" var="labelcomment"/>
<orion:message key="scor.task.ob.commentError" var="labelcommentError" escape="javascript"/>
<orion:message key="scor.error.dialogBox.title" var="scorErrorDialogBoxTitle" escape="javascript"/>
<orion:message key="scor.task.ob.workflowID.help.text" var="workflowidhelptext"/>
<orion:message key="scor.general.alertMsg" var="generalAlertMsg" escape="javascript" />

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.OBSERVE_MODE_CLIENT_TASK_PAGE%>");
</script>

<script type= "text/javascript">

function epoOnBeforeSubmit() {
    return finalvalidate() ;
}

function finalvalidate()
{
    if ( OrionForm.isFormValid() == false ) {
    	alert("${generalAlertMsg}");
    	return false;
    }
    var workflowidbox = document.getElementById("workflow_id");
    var commentbox = document.getElementById("comment");

    if(workflowidbox.value === "" && commentbox.value!== ""){
        OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        OrionCore.showDialogBox(true, '${labelcommentError}', OrionCore.DIALOG_OK);
        return false;
    }
    return true;
   
}

function onStartObModeSelected() {
    var enableSsOnobModeEndButton = $('enableSsOnobModeEndButton');
    var disableSsOnobModeEndButton = $('disableSsOnobModeEndButton');
    var updateInvOnObModeEnd = $('updateInvOnObModeEnd');
    enableSsOnobModeEndButton.disabled = true;
    disableSsOnobModeEndButton.disabled = true;
    if (updateInvOnObModeEnd) {
    	updateInvOnObModeEnd.disabled = true;
    } 

    var workflowidbox = document.getElementById("workflow_id");
    var commentbox = document.getElementById("comment");
    workflowidbox.disabled = false;
    commentbox.disabled = false;
}

function onEndObModeSelected() {
    var enableSsOnobModeEndButton = $('enableSsOnobModeEndButton');
    var disableSsOnobModeEndButton = $('disableSsOnobModeEndButton');
    var updateInvOnObModeEnd = $('updateInvOnObModeEnd');
    enableSsOnobModeEndButton.disabled = false;
    disableSsOnobModeEndButton.disabled = false;
    if (updateInvOnObModeEnd) {
    	updateInvOnObModeEnd.disabled = false;
    } 

    var workflowidbox = document.getElementById("workflow_id");
    var commentbox = document.getElementById("comment");
    workflowidbox.disabled = true;
    commentbox.disabled = true;
    
}

function initObModeTaskUI() {
    var isObModeStartChecked = $('obModeStartButton').checked;
    if (isObModeStartChecked === true) {
	onStartObModeSelected();
    } else {
	onEndObModeSelected();
    }
}

</script>

<orion:box>
<div class="orionDescriptionArea orionBorderBottomGrey">
    ${obModeHelpText}
</div>
<table  cellspacing="0" cellpadding="0" width="100%" style="width:100%;" id="generalTab">
    <tr>
	<td class="orionSummaryHeader" valign="top">
	    ${obModeLabel}
	</td>
	<td class="orionSummaryColumn" valign="top">
	    <orion:radiobutton id="obModeStartButton" value="startObMode"
	    name="obModeOption" checked="${isObModeStartChecked}"
	    text="${obModeStartLabel}" disabled="${epoReadOnlyTask}" onclick="onStartObModeSelected();" />
	    <br />

    <table>
        <tr>
            <td valign="top" style="white-space: nowrap">
                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;${labelWorkflowID}
            </td>
            <td >
                <orion:textbox id="workflow_id" name="workflow_id" required="false" value="${workflow_id}" disabled="${epoReadOnlyTask}"/>
                <br>
                    ${workflowidhelptext}
            </td>
        </tr>
        <tr>
            <td valign="top">
                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;${labelcomment}
            </td>
            <td >
                <orion:textbox id="comment" name="comment" required="false" value="${comment}" disabled="${epoReadOnlyTask}"/>
            </td>
        </tr>
    </table>


	    <orion:radiobutton id="obModeEndButton" value="endObMode"
	    name="obModeOption" checked="${isObModeEndChecked}"
	    text="${obModeEndLabel}" disabled="${epoReadOnlyTask}" onclick="onEndObModeSelected();" />
	    <br />
	    &nbsp;&nbsp;&nbsp;<orion:radiobutton id="enableSsOnobModeEndButton"
	    value="enableSsOnObModeEnd"
	    name="ssStatusOnObModeEnd"
	    checked="${isEnableSsOnObModeEndChecked}"
	    text="${enableSsOnObModeEndLabel}" disabled="${epoReadOnlyTask}"/>
	    <br />

	    &nbsp;&nbsp;&nbsp;<orion:radiobutton id="disableSsOnobModeEndButton"
	    value="disableSsOnObModeEnd"
	    name="ssStatusOnObModeEnd"
	    checked="${isDisableSsOnObModeEndChecked}"
	    text="${disableSsOnObModeEndLabel}" disabled="${epoReadOnlyTask}"/>
	    <br />
	</td>
    </tr>
    <c:if test="${isBackwardCompatibleObsEnabled}">
	    <tr>
			<td class="orionSummaryHeader" valign="top">
			    ${updateInvOnObModeEndLabel}
			</td>
			<td class="orionSummaryColumn" valign="top">
			    &nbsp;&nbsp;&nbsp;<orion:checkbox id="updateInvOnObModeEnd"
			    name="updateInvOnObModeEndName" checked="${isUpdateInvOnObModeEndChecked}"
			    text="${updateInvOnObModeEndDesc}" disabled="${epoReadOnlyTask}"/>
			</td>
	    </tr>
    </c:if>

</table>

</orion:box>

<script type="text/javascript">
    OrionCore.addLoadHandler(initObModeTaskUI);
</script>
