<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%@ page import="com.mcafee.scor.common.CommonUtilities" %>
<orion:core>
	<orion:corehead>
		<orion:style context="/core" url="/tag/table2/table.css" />
	</orion:corehead>
	<orion:corebody>
		<orion:navigation/>
		<orion:content>
			<orion:message var="cloudBinaryDetailTitle" key="scor.cloud.cloudBinaryDetail.title" escape="none"/>
			<orion:message var="SoftwarePackagesForBinary" key="scor.cloud.cloudBinaryDetail.softwarePackages" escape="none" params="${binaryName}"/>
			<orion:message var="SignaturesForBinary" key="scor.cloud.cloudBinaryDetail.signatures" escape="none" params="${binaryName}"/>
			<orion:message var="CloudBinarySoftwarePackageName" key="scor.cloud.cloudBinaryDetail.softwarePackageName" escape="html" />
			<orion:message var="CloudBinarySoftwarePackageVendor" key="scor.cloud.cloudBinaryDetail.softwarePackageVendor" escape="html" />
			<orion:message var="CloudBinarySoftwarePackageVersion" key="scor.cloud.cloudBinaryDetail.softwarePackageVersion" escape="html" />
			<orion:message var="CloudBinarySignatureSubjectName" key="scor.cloud.cloudBinaryDetail.signatureSubject" escape="html" />
			<orion:message var="CloudBinarySignatureIssuerName" key="scor.cloud.cloudBinaryDetail.signatureIssuer" escape="html" />
			<orion:message var="CloudBinarySignatureValidFrom" key="scor.cloud.cloudBinaryDetail.signatureValidFrom" escape="html" />
			<orion:message var="CloudBinarySignatureValidTo" key="scor.cloud.cloudBinaryDetail.signatureValidTo" escape="html" />
			
			<orion:vbox>
				<orion:titlebar text="${cloudBinaryDetailTitle}" />
				<orion:box>
					<orion:propertylist id="scor.cloudBinaryDetail.id" item="${cloudBinaryDetail}" displayAdapter="${cloudBinaryDetailDA}"/>
				</orion:box>
				<orion:box height="7" background="#474747"/>
				<orion:box>
					<orion:titlebar text="${SoftwarePackagesForBinary}" />
					<c:choose>
						<c:when test="${cloudBinaryDetail.softwarePackageList == null}">
							<orion:message key="scor.cloud.cloudBinaryDetail.noSoftwarePackageFound" escape="none"/>
						</c:when>
						<c:otherwise>
							<table id="softwarePackageTable" width="100%" cellspacing="1" cellpadding="4" >
								<tr class="tableHeader">
									<td>${CloudBinarySoftwarePackageName}</td>
									<td>${CloudBinarySoftwarePackageVendor}</td>
									<td>${CloudBinarySoftwarePackageVersion}</td>
								</tr>
								<c:forEach var="sofwarePackage" items="${cloudBinaryDetail.softwarePackageList}" varStatus="rowCounter">
									<c:choose>
										<c:when test="${rowCounter.count%2 == 0}">
											<c:set var="rowStyle" value="alternateRow"/>
										</c:when>
										<c:otherwise>
											<c:set var="rowStyle" value="" />
										</c:otherwise>
									</c:choose>
									<tr class="${rowStyle}">
										<td>${sofwarePackage.name}</td>
										<td>${sofwarePackage.vendor}</td>
										<td>${sofwarePackage.version}</td>
									</tr>
								</c:forEach>
							</table>
						</c:otherwise>
					</c:choose>
				</orion:box>
				<orion:box height="7" background="#474747"/>
				<orion:box>
					<orion:titlebar text="${SignaturesForBinary}" />
					<c:choose>
						<c:when test="${cloudBinaryDetail.signatureList == null}" >
							<orion:message key="scor.cloud.cloudBinaryDetail.noSignatureFound" escape="none"/>
						</c:when>
						<c:otherwise>
							<table id="certificateListTable" width="100%" cellspacing="1" cellpadding="4">
								<tr class="tableHeader">
									<td>${CloudBinarySignatureSubjectName}</td>
									<td>${CloudBinarySignatureIssuerName}</td>
									<td>${CloudBinarySignatureValidFrom}</td>
									<td>${CloudBinarySignatureValidTo}</td>
								</tr>
								<c:forEach var="signature" items="${cloudBinaryDetail.signatureList}" varStatus="rowCounter">
									<c:choose>
										<c:when test="${rowCounter.count%2 == 0}">
											<c:set var="rowStyle" value="alternateRow"/>
										</c:when>
										<c:otherwise>
											<c:set var="rowStyle" value="" />
										</c:otherwise>
									</c:choose>
									<tr class="${rowStyle}">
										<td>${signature.subjectName}</td>
										<td>${signature.issuerName}</td>
										
										<td id="scor.cloudbinarydetail.validFromTimestamp">${signature.validFromTimestamp}</td>
										<td id="scor.cloudbinarydetail.validToTimestamp">${signature.validToTimestamp}</td>

										<script language="JavaScript">
										
											var validFromTime = document.getElementById("scor.cloudbinarydetail.validFromTimestamp");
											var validFromTimeMillis = parseInt(validFromTime.innerHTML);
											if (validFromTimeMillis > 0) {
												var validFromTimeDate = new Date(validFromTimeMillis);
												validFromTime.innerHTML = validFromTimeDate;
											} else {
												validFromTime.innerHTML = "";
											}
											
											var validToTime = document.getElementById("scor.cloudbinarydetail.validToTimestamp");
											var validToTimeMillis = parseInt(validToTime.innerHTML);
											if (validToTimeMillis > 0) {
												var validToTimeDate = new Date(validToTimeMillis);
												validToTime.innerHTML = validToTimeDate;
											} else {
												validToTime.innerHTML = "";
											}
										
										</script>
									</tr>
								</c:forEach>
							</table>
						</c:otherwise>
					</c:choose>
				</orion:box>
				<%@ include file="../BackCloseFooter.jsp" %>
			</orion:vbox>
		</orion:content>
	</orion:corebody>
</orion:core>
