<%-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<orion:message key="scor.ruleGroupJsp.addToExisting"
               var="addToExisting" escape="none" />
<orion:message key="scor.ruleGroupJsp.createNew" var="createNew"
               escape="none" />
<orion:message key="scor.ruleGroupJsp.addToRuleGroup"
               var="addToRuleGroup" escape="html" />


<orion:box id="scorSelectRuleGroupDiv">
    <table>        
        <tr>
            <td colspan=2 align="left" style="align:left;font-weight: bold;">&nbsp;&nbsp;${addToRuleGroup}<c:if test='${scorRuleGroupType != null && scorRuleGroupType != ""}'> : ${scorRuleGroupType}</c:if>
            </td>
        </tr>
        <tr>    
			<td align="left" style="width:100px">&nbsp;</td>
            <td align="left" style="width:175px"><orion:radiobutton id="addToExistingRuleGroupOption"
                                   name="addToRuleGroupOption" value="addToexisting"
                                   text="${addToExisting}" onclick="scor.rg.sel.enableDisableTxtBox();" /></td>
			<td align="left">&nbsp;<orion:select id="scorGroupsSelectId" name="selectedGroupId"
                              items="${scorSelectListForGroupNames}" /></td>
        </tr>
        <tr>
        	<td align="left" style="width:100px">&nbsp;</td>
            <td align="left" style="width:175px"><orion:radiobutton id="addToNewRuleGroupOption"
                                   name="addToRuleGroupOption" value="createNew" text="${createNew}"
                                   checked="true" onclick="scor.rg.sel.enableDisableTxtBox();" /></td>
			
            <td align="left">&nbsp;<orion:textbox id="newGroupHtmlId" name="newGroupName"
                               required="true" size="20" />
             	<span id="scor.rg.already.exists.err" class="errorText" style="display:none;">
            	&nbsp;<orion:message key="scor.ruleGroupJsp.ruleGroupExistsErrorMsg" escape="html" />
            	</span>
                               
            </td>
        </tr>
    </table>
</orion:box>

<script type="text/javascript">
    var scor = scor || {};
    scor.rg = scor.rg || {};
    

    
    scor.rg.sel = function() {
    	var onValidCb = null;
    	var onInvalidCb = null;
    	var checkValidNewGroupPrivate;
    	return {
    		setOnValidCallback: function(callback) {
    			if (typeof callback === 'function') {
    				onValidCb = callback;
    			}
    		},
    		setOnInvalidCallback: function(callback) {
    			if (typeof callback === 'function') {
    				onInvalidCb = callback;
    			}
    		},
    		onExistingGroupChange: function() {
    			$('scor.rg.already.exists.err').style.display = 'none';
    			if (typeof onValidCb === 'function') {
    				onValidCb();
    			}
    		},
    		onNewGroupCheckChange: function() {
    			var ruleGroupVal = $('newGroupHtmlId').value;
    			if(ruleGroupVal !== '') {
    	        	var valid = scor.rg.sel.checkValidNewGroup(ruleGroupVal, $('scorGroupsSelectId'));
    	        	if (valid) {
    	        		$('scor.rg.already.exists.err').style.display = 'none';
    	        		if (typeof onValidCb === 'function') {
    	        			onValidCb();
    	        		}
    	        	} else {
    	        		$('scor.rg.already.exists.err').style.display = '';
    	        		if (typeof onInvalidCb === 'function') {
    	        			onInvalidCb();
    	        		}
    	        	}
    			} else {
    				$('scor.rg.already.exists.err').style.display = 'none';
    				if (typeof onInvalidCb === 'function') {
    					onInvalidCb();
    				}
    			}
    		},
    		init : function() {
    	    	if($('scorGroupsSelectId').length == 0){
    	    		$('addToExistingRuleGroupOption').disabled = true;
    	    	}
    	    	scor.rg.sel.fixSelectBoxWidth();
    			OrionEvent.registerHandlerById('newGroupHtmlId', scor.rg.sel.onNewGroupCheckChange, null, 'keyup', false);
    			OrionEvent.registerHandlerById('addToNewRuleGroupOption', scor.rg.sel.onNewGroupCheckChange, null, 'click', false);
    			OrionEvent.registerHandlerById('addToExistingRuleGroupOption', scor.rg.sel.onExistingGroupChange, null, 'click', false);
    			$('scorGroupsSelectId').disabled = true;//By default new rg option is selected.
    	    },
    		checkValidNewGroup : function(groupName, groupList) {
    			if(groupName === "") {
    			   	if (typeof onInvalidCb === 'function') {
    					onInvalidCb();
    				}
    				return false;
    			} else {
    				for(var i=0; i < groupList.length; i++)
    				{
    					var currentGroup = groupList.options[i].text;
    					if(typeof currentGroup == 'string' && typeof groupName == 'string' &&
    							currentGroup.toLowerCase() === groupName.toLowerCase()){
    						if (typeof onInvalidCb === 'function') {
    							onInvalidCb();
    						}
    						return false;
    					}
    			    }
    			}
    			if (typeof onValidCb === 'function') {
    				onValidCb();
    			}
    			return true;
    		},
    		fixSelectBoxWidth : function() {
    			if("${fixSelectBoxWidth1}" === "false"){
    				<!-- Do nothing-->
    			}else{		
    				$j('#scorGroupsSelectId').width(${selectBoxWidth});
    				$j('#newGroupHtmlId').width(${selectBoxWidth});
    			}
    		},
    		enableDisableTxtBox : function() {
    	    	var newGroupTxtBox = $('newGroupHtmlId');
    	    	if ($('addToNewRuleGroupOption').checked === true) {
    	    		$('scorGroupsSelectId').disabled = true;
    	    		newGroupTxtBox.disabled = false;
    	    			if (typeof onInvalidCb === 'function') {
    							onInvalidCb();
    						}
    	    	} else {
    	    		newGroupTxtBox.disabled = true;
    	    		$('scorGroupsSelectId').disabled = false;
    	    	}
    	    }
    	};
    }();
    
    
    OrionCore.addLoadHandler(scor.rg.sel.init);   
</script>
