<!-- COPYRIGHT:		Copyright (C) 2019 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<orion:message key="scor.cpe.export.radio.copyClipBoard.text" var="copytoclipboard" escape="html"/>
<orion:message key="scor.cpe.export.radio.exportXml.text" var="exportXml" escape="html"/>
<orion:message key="scor.cpe.export.type.text" var="exportType" escape="html"/>
<orion:core>

<orion:corehead>

    <script type="text/javascript">
        function clickCancel()
        {
            OrionNavigation.lastTablePage();
        }

        function _initialize()
        {
            OrionForm.setStateChangeHandler( _exportFormHandler );
            OrionForm.revalidate();
        }
        function _exportFormHandler( isDirty, isValid )
        {
            // make sure that we have either directory or email configured
            //var expBtn = $("export.target.download");
            var valid = true;
            OrionCore.setEnabledById( "exportOk", valid && isValid);
        }
    </script>


</orion:corehead>

<orion:corebody useForm="true" onload="_initialize();">
    <orion:tunnelPage helpId="ss" >
        <orion:vbox>
            <orion:box height="24">
                <div class="tunnelPageTitleBar">
                    <orion:message key="scor.cpe.export.header.text" />
                </div>
            </orion:box>
            <orion:box height="auto">
            <table class="orionSummary" width="100%">
                <tbody>
                    <tr>
                        <td class="orionSummaryHeader">
                            <orion:message key="scor.cpe.export.header.text" />
                        </td>
                        <td class="orionSummaryColumn">
                            <!-- no escape needed, since we already escaped it before we sent it to the screen, and there is some required html for warning messages-->
                            <c:forEach items="${exportCpeInformation}" var="info">
                                ${info}<br>
                            </c:forEach>
                        </td>
                    </tr>
                    <tr>
                        <td class="orionSummaryHeader">
                            <orion:message key="scor.cpe.export.generate.text" />
                        </td>
                        <td class="orionSummaryColumn">
                            <orion:textbox id="otherFieldtxt" name="otherFieldtxt" required="true" size="50" maxlength="50" />

                        </td>
                    </tr>
                    <tr>
                        <td class="orionSummaryHeader">

                                ${exportType}
                        </td>
                        <td class="orionSummaryColumn" id="type" valign="top">
                                <orion:message var="typeTEXTText" key="scor.cpe.export.fileFormat.file.texttype.text" escape="none" />
                                <orion:radiobutton id="export.text.id"
                                                   value="txt"
                                                   name="exportType"
                                                   text="${typeTEXTText}"
                                                   />
                            <br />
                                <orion:message var="typeXMLText" key="scor.cpe.export.fileFormat.file.xmltype.text" escape="none" />
                                <orion:radiobutton id="export.xml.id"
                                                   value="xml"
                                                   name="exportType"
                                                   text="${typeXMLText}"

                                                   checked="true" />
                            <br />
                    </tr>
                </tbody>
            </table>
            </orion:box>
            <orion:box height="32">
                <div class="buttonBarFooter">
                    <orion:message var="exportOkText" key="scor.cpe.export.button.ok.text" escape="none" />
                    <orion:message var="exportCancelText" key="scor.cpe.export.button.cancel.text" escape="none" />
                    <orion:button id="exportOk"
                                  text="${exportOkText}"
                                  onclick="clickOk();" />
                    <orion:button id="exportCancel"
                                  text="${exportCancelText}"
                                  onclick="clickCancel();" />
                </div>
            </orion:box>
        </orion:vbox>
        <input type="hidden" name="selectedIds" value="${uuids}" />
    </orion:tunnelPage>
</orion:corebody>
</orion:core>
<script type="text/javascript">
    function clickOk(){
         OrionCore.showPleaseWait(true);
         setTimeout(_exportCustomXml, 300);
         return true;
        //_exportCustomXml()
    }

    function _exportCustomXml(){
        OrionCore.doAsyncFormAction('/SOLIDCORE_META/exportCpeCustom.do', null, _exportSuccess, _exportFailure);
        return true;
    }
    function _exportSuccess(){
        OrionCore.doAction('/SOLIDCORE_META/exportCpeCustomResults.do');
    }

    function _exportFailure( status, results ){
        OrionCore.showPleaseWait(false);
        OrionCore.doAction("/core/showFriendlyErrorMessage.do", [], 'get');
    }

</script>