<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>

<orion:core>
    <orion:corehead/>
    <orion:corebody>
        <orion:navigation/>
        <orion:content>
            <script type="text/javascript">
                OrionHelp.setHelpId("${helpPageId}");
            </script>

            <orion:message var="fileRevisionsTableTitle" key="scor.fileDiff.table.fileRevisions.tableTiele" escape="none"/>
            <orion:message var="sysName" key="scor.fileDiff.table.fileRevisions.sysName" escape="html"/>
            <orion:message var="fileName" key="scor.fileDiff.table.fileRevisions.fileName" escape="html"/>
            <orion:vbox>
                <orion:box background="rgb(235, 235, 235);" height="50">
                    <table>
                        <tr>
                            <td><strong>${sysName}</strong> </td>
                            <td>${scorFileInfo.systemName}</td>
                        </tr>
                        <tr>
                            <td><strong>${fileName}</strong> </td>
                            <td id="filePathCell" title="${scorFileInfo.filePath}">${displayFilePath}</td>
                        </tr>
                    </table>
                </orion:box>

                <orion:vbox>
                    <orion:table2 id="scor.fileDiff.table.fileRevisions"
                                  titleText="${fileRevisionsTableTitle}"
                                  allowExport="true"
                                  datasourceAttr="scor_FILE_REVISIONS_DS_ATTR"
                                  cellRendererAttr="scor_FILE_REVISIONS_CR_ATTR"
                                  showCheckboxColumn="true"
                                  columnWidths="7,8,15,18,18,10,24"
                                  properties="version,change,detectedTimestamp,modifiedBy,program,fileEncoding,actions"
                                  sortColumn="version"
                                  sortOrder="1"
                                  allowFilter="false"
                                  enableDrilldown="false"
                                  registeredTypeUID="scor.rt.filediff.filerevision.actions.uid"/>
                   <div id="" class="layout_box_32_ OrionFooterBar" style="overflow: hidden; flex-basis: 32px;">
                       <div class="OrionFooterBarContainer" id="_content">
                           <input id="backButton" class="orionButtonEnabled" type="button" onclick="OrionNavigation.lastAnchorPage()" title="Back" value="Back">
                           <input id="closeButton" class="orionButtonEnabled" type="button" onclick="OrionNavigation.lastAnchorPage()" title="Close" value="Close">
                       </div>
                   </div>
                </orion:vbox>
                <script type="text/javascript">

                    var scorFileRevisionsTable;

                    function scorFileRevisionsInit(){
                        scorFileRevisionsTable = MFSTable.get("scor.fileDiff.table.fileRevisions");
                        scorFileRevisionsTable.setOnStateChange( scorFileRevisionsTableStateChanged );
                    }

                    function scorFileRevisionsTableStateChanged(){
                        var selectedUids = scorFileRevisionsTable.getSelected().split(",");
                        for(var i in OrionAction.actionList){
                            if(OrionAction.actionList[i].actionURI.indexOf("compareFiles.do") != -1){
                                if(selectedUids.length == 2){
                                    OrionAction.actionList[i].disabled = false;
                                }else{
                                    OrionAction.actionList[i].disabled = true;
                                }
                            }
                        }
                    }
                    
                    OrionCore.addLoadHandler(scorFileRevisionsInit);
                </script>
            </orion:vbox>
        </orion:content>
    </orion:corebody>
</orion:core>
