<%-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved --%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.inventory.InventoryConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<orion:core>
   <orion:corehead>
   
<orion:message key="scor.inv.aef.selectviewtype" var="selectViewTypeTitleText"  escape="none"/>
<orion:message key="scor.inv.aef.removeaef" var="removeButtonText" escape="none"/>
<orion:message key="scor.inv.aef.updateaef" var="updateButtonText" escape="none"/>
<orion:message key="scor.inv.aef.closeaef" var="closeButtonText" escape="none"/>
<orion:message key="scor.inv.aef.selectfilterwithvalue" var="selectFilterValue" escape="javascript"/>
<orion:message key="scor.inv.aef.invalidfilterconfig" var="notValidAef" escape="javascript"/>
<orion:message key="scor.inv.aef.viewtype" var="viewText"/>
<orion:message key="scor.inv.aef.binaries" var="binariesCb" escape="none" />
<orion:message key="scor.inv.aef.systems" var="systemsCb" escape="none" />
<orion:message key="scor.inv.aef.apps" var="appsCb" escape="none" />
<orion:message key="scor.inv.aef.vendors" var="vendorsCb" escape="none" />

<c:if test="${not empty invSearchName}">
<orion:message key="scor.inv.aef.forsavedsearch" var="forSavedSearch"  escape="none"/>
</c:if>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/commonUtil.js"/>	

<script type="text/javascript">
//	OrionCore.addLoadHandler(onPageLoad);

    var savedxmlstr = "${orion:escapeJavaScript(conditionXML)}";

	var shouldEdit = ${param.shouldEdit};

    function onPageLoad()
    {	OrionHelp.setHelpId("solidcore_600/source/pageref/ref_edit_filter_criteria.html"); // change it
        CriteriaBuilder.setChangeHandler( _onCriteriaChange );
		<c:choose>
    		<c:when test="${!empty criteria_error}">
        		<orion:message key="query_criteria_error_title" var="criteria_error_title"
                       	escape="html" plugin="console"/>
        		OrionCore.dialogBoxOkHandler = loadSavedCriteria;
        		OrionCore.setDialogBoxTitle( "${orion:escapeJavaScriptString(criteria_error_title)}" );
        		OrionCore.showDialogBox(true, "${orion:escapeJavaScriptString(criteria_error)}", OrionCore.DIALOG_OK);
    		</c:when>
   	   		<c:otherwise>
        		loadSavedCriteria();
       		</c:otherwise>
		</c:choose>
    }

    function loadSavedCriteria(){
        CriteriaBuilder.loadSavedCriteria( savedxmlstr );
    }

    function _onCriteriaChange( ){
            //OrionWizard.enableNavigation();
    }
    
    function updateFilter(){
    	if(!isValidXml()){
    		showSelectFilterWithValueDialog();    		
    		return;
    	}
       
        var invPageSourceValue = "${invPageSource}";

        
        if(shouldEdit === false){
            var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML(),"invViewType",getViewType(),"invPageSource",invPageSourceValue];        	
        	scor.actions.doAsyncAction("/SOLIDCORE_META/updateInvAdvFilterCriteria.do",paramMap, navigateToInvPage);
        	OrionCore.showPleaseWait(true);	
        }
        
        if(shouldEdit === true){
            var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML(),"invViewType",getViewType(),"invPageSource",invPageSourceValue,"scorInvSavedSearchId",${param.scorInvSavedSearchId}];
        	scor.actions.doAsyncAction("/SOLIDCORE_META/editInvAdvFilterCriteria.do",paramMap, navigateToInvPage);
        	OrionCore.showPleaseWait(true);
        }
     }
     
    function removeFilter(){
        var invPageSourceValue = "${invPageSource}";
        var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML(),"invPageSource",invPageSourceValue];
        scor.actions.doAsyncAction("/SOLIDCORE_META/removeInvAdvFilterCriteria.do",paramMap, navigateToInvPage);
        
        OrionCore.showPleaseWait(true);
     }
     
    function closeCriteria(){
        OrionCore.showPleaseWait(true);
        navigateToInvPage();	       
     }
     
     function navigateToInvPage(){
        OrionCore.showPleaseWait(false);
             
        var invPageSourceValue = "${invPageSource}";
        var paramMap = ["invPageSource",invPageSourceValue];
        OrionCore.doAction("/SOLIDCORE_META/navigateToInv.do", paramMap, "GET","_self");
     }
     
     function isValidXml(){
     	var conditionXml = CriteriaBuilder.getCriteriaXML();     	
     	$j("#conditionTable").find("input[type=text]").each(function() {
     	    InputBoxId = $j(this).attr("id");
     	    if (!scor.common.isValidText($j("#"+InputBoxId).val())) {
     	        $j("#"+InputBoxId).val("");     	        
     	        conditionXml = "";
     	        showSelectFilterWithValueDialog();    		
		        return;
     	    }
     	})	    
       	
     	if(conditionXml === '<conditions></conditions>'){
     		return false;
     	}
     	if(conditionXml === ""){
     		return false;
     	}
     	return true;
     }

     function showSelectFilterWithValueDialog(){
        OrionCore.showDialogBox(true, '${selectFilterValue}', OrionCore.DIALOG_OK);
    	OrionCore.setDialogBoxTitle('${notValidAef}');
     }
     
     function getViewType(){
     	for (var i=0; i < 3; i++){
     			if (document.getElementsByName('invViewType')[i].checked){
      				return document.getElementsByName('invViewType')[i].value;
      			}
   		}
     }
     
</script>



   </orion:corehead>
   <orion:corebody onload="onPageLoad()">
      <orion:navigation />
      <orion:content>
<orion:vbox>

<c:if test="${invPageSource ne 'invPageSourceSystem'}">
	<orion:box height="65">     
		<orion:box>
			 <c:if test="${invPageSource eq 'invPageSourceApp'}">
			 	<orion:titlebar text="${selectViewTypeTitleText} ${forSavedSearch} ${invSearchDisplayName}" />
			    &nbsp;&nbsp;<b>${viewText}</b>:&nbsp;&nbsp;
			    
				<c:if test="${invViewType eq 'invBinaryView'}">
			    <orion:radiobutton id="invBinaryViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_BINARY%>" text="${binariesCb}" checked="true" onClick="getViewType()" />
			 	</c:if>
			 	<c:if test="${invViewType != 'invBinaryView'}">
			    <orion:radiobutton id="invBinaryViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_BINARY%>" text="${binariesCb}" checked="true" onClick="getViewType()" />
			 	</c:if>
				
				<c:if test="${invViewType eq 'invAppView'}">
				<orion:radiobutton id="invAppViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_APP%>" text="${appsCb}" checked="true" onClick="getViewType()" />
				</c:if>
				<c:if test="${invViewType != 'invAppView'}">
				<orion:radiobutton id="invAppViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_APP%>" text="${appsCb}" onClick="getViewType()" />
				</c:if>
				
				<c:if test="${invViewType eq 'invVendorView'}">
				<orion:radiobutton id="invVendorViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_VENDOR%>" text="${vendorsCb}" checked="true" onClick="getViewType()" />
			    </c:if>
			    <c:if test="${invViewType != 'invVendorView'}">
				<orion:radiobutton id="invVendorViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_VENDOR%>" text="${vendorsCb}" onClick="getViewType()" />
			    </c:if>
		 	</c:if>
			 
			 <c:if test="${invPageSource eq 'invPageSourceAppSystem'}">	
			 	<orion:titlebar text="${selectViewTypeTitleText} ${forSavedSearch} ${invSearchDisplayName}" />
			    &nbsp;&nbsp;<b>${viewText}</b>:&nbsp;&nbsp;
			    	 	
			 	<c:if test="${invViewType eq 'invBinaryView'}">
			    <orion:radiobutton id="invBinaryViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_BINARY%>" text="${binariesCb}" checked="true" onClick="getViewType()" />
			    </c:if>
			 	<c:if test="${invViewType != 'invBinaryView'}">
			    <orion:radiobutton id="invBinaryViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_BINARY%>" text="${binariesCb}" checked="true" onClick="getViewType()" />
			    </c:if>	
			 	
			 	<c:if test="${invViewType eq 'invAppView'}">
			 	<orion:radiobutton id="invAppViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_APP%>" text="${appsCb}" checked="true" onClick="getViewType()" />				
				</c:if>
				<c:if test="${invViewType != 'invAppView'}">
			 	<orion:radiobutton id="invAppViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_APP%>" text="${appsCb}" onClick="getViewType()" />				
				</c:if>
				
				<c:if test="${invViewType eq 'invVendorView'}">
				<orion:radiobutton id="invVendorViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_VENDOR%>" text="${vendorsCb}" checked="true" onClick="getViewType()" />
			    </c:if>
			    <c:if test="${invViewType != 'invVendorView'}">
				<orion:radiobutton id="invVendorViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_VENDOR%>" text="${vendorsCb}" onClick="getViewType()" />
			    </c:if>			 
			 </c:if>
		</orion:box>
	</orion:box>
</c:if>
<c:if test="${invPageSource eq 'invPageSourceSystem'}">
	<orion:box height="1">
			<SPAN style="display:none">
					<orion:radiobutton id="invSystemsViewCB"  name="<%=InventoryConstants.INV_VIEW_TYPE%>" value="<%=InventoryConstants.INV_VIEW_SYSTEM%>" text="${systemsCb}" checked="true" onClick="getViewType()" />	 
			</SPAN>
	</orion:box>
</c:if>

         			<orion:criteriabuilder context="/SOLIDCORE_META"
                                       listContentURI="loadInvAdvFilterCriteria.do"
             	                     emptyText="" />                        

         <orion:footerbar>        
         		<orion:button id="updateFilterButton" text="${updateButtonText}" onclick="updateFilter()"/>
         		<orion:button id="removeFilterButton" text="${removeButtonText}" onclick="removeFilter()"/>
         		<orion:button id="closeButton" text="${closeButtonText}" onclick="closeCriteria()"/>
         </orion:footerbar>

	
</orion:vbox>
      </orion:content>
   </orion:corebody> 
</orion:core> 
