<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved. -->
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.policy.PolicyConstants" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<c:set var="WIN_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.WIN.getValue()%>"/>
<c:set var="UNIX_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.UNIX.getValue()%>"/>

<orion:style context="/SOLIDCORE_META" url="/css/override.css" />
<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/commonUtil.js"/>

<orion:message key="policy.mon.file.fileDiff.enable" var="fileDiffEnable" escape="none"/>
<orion:message key="policy.mon.include" var="include" escape="html"/>
<orion:message key="policy.mon.exclude" var="exclude" escape="html"/>
<orion:message key="policy.mon.filter" var="filter" escape="javascript"/>
<orion:message key="policy.mon.filters" var="filters" escape="javascript"/>

<orion:message key="policy.mon.file.filters.duplicate" var="valFileFilterDuplicate" escape="javascript"/>
<orion:message key="policy.mon.reg.filters.duplicate" var="valRegFilterDuplicate" escape="javascript"/>
<orion:message key="policy.mon.reg.filters.noStarAtEnd" var="valRegFilternoStarAtEnd" escape="javascript"/>
<orion:message key="policy.mon.reg.filters.noStarInBetwn" var="valRegFilternoStarInBetwn" escape="javascript"/>
<orion:message key="policy.mon.reg.filters.mustBeginWith" var="valRegFilterMustBeginWith" escape="javascript"/>
<orion:message key="policy.mon.users.filters.duplicate" var="valUserFilterDuplicate" escape="javascript"/>
<orion:message key="policy.mon.program.filters.duplicate" var="valProgramFilterDuplicate" escape="javascript"/>
<orion:message key="policy.mon.extn.filters.duplicate" var="valExtnFilterDuplicate" escape="javascript"/>


<orion:message key="policy.mon.filters.empty" var="valFilterEmpty" escape="javascript"/>
<orion:message key="scor.policy.mon.file" var="file" escape="html"/>
<orion:message key="scor.policy.mon.registry" var="registry" escape="html"/>


<SCRIPT type="text/javascript">


function fnCommonAddEditFilterCallback(validatorFunction, dialogTitle, list) {
    var dialogValue = getDialogBoxFilterValues();
    var inputField = dialogValue.field;
    var criteriaFieldChecked = dialogValue.criteria;
    var criteriaFieldUnChecked = dialogValue.criteriaUnchecked;

    OrionForm.revalidate();

    var inputFieldHandler = function() {
        validatorFunction(false, '${orion:escapeJavaScriptString(param.osType)}', list);
    }

    OrionEvent.registerHandler(inputField,inputFieldHandler, null, "keyup", false);

    OrionCore.setDialogBoxTitle(dialogTitle);
    setRadioButtonAndCheckBox();
    existingOkHanlder = OrionCore.dialogBoxOkHandler;
    OrionCore.dialogBoxOkHandler = function () {
        var allOk = validatorFunction(true, '${orion:escapeJavaScriptString(param.osType)}', list);
        if (allOk) {
        	OrionEvent.unregisterHandler(inputField, inputFieldHandler, "keyup", false);
            addOrEditOkHandler();
        } else {
            return false;
        }
    }
}

function fnAddEditRegistryFilterCallback(title){
    fnCommonAddEditFilterCallback(isRegistryFilterValid, title, registryFilterList);
	
}
function fnAddRegistryFilterCallback(){
	fnAddEditRegistryFilterCallback('<orion:message key="policy.mon.reg.add.filters" escape="javascript"/>');
}
function fnEditRegistryFilterCallback(){
	 var selectedRow = registryFilterList.selrow;
	  if(selectedRow){
		  fnAddEditRegistryFilterCallback('<orion:message key="policy.mon.reg.edit.filters" escape="javascript"/>');
	   } else{
	          return;
	       }
 }

var handleError = function(isValid, msg) {
    scor.validation.processValidationResult(new scor.validation.constructors.ValidationResult(isValid, msg));
    return isValid;
}

var getDialogBoxFilterValues = function() {
    var dialogNode = OrionCore.getDialogBoxContainer();
    var field = scorFindElementById(dialogNode, 'input', 'field');

    var children = dialogNode.getElementsByTagName("input");
    var includeRadio;
    var excludeRadio;
    var radioChecked;
    var radioUnChecked;
    for (var i = 0; i < children.length; i++) {
        if (children[i].type && children[i].type == "radio") {
            if (children[i].value == "Include") {
                includeRadio = children[i];
            } else if (children[i].value == "Exclude") {
                excludeRadio = children[i];
            }
        }
    }

    if (includeRadio && excludeRadio) {
        if (includeRadio.disabled) {
            radioChecked = excludeRadio;
            radioUnChecked = includeRadio;
        } else {
            radioChecked = includeRadio.checked ? includeRadio : excludeRadio;
            radioUnChecked = includeRadio.checked ? excludeRadio : includeRadio;
        }
    }


    return {'field': field, 'criteria': radioChecked, 'criteriaUnchecked': radioUnChecked};

}

var isRegistryFilterValid = function (onOkClick, os, list) {
    var isValid = true;
    var msg = "";
    var re;
    var isValidObj;

    var dialogValue = getDialogBoxFilterValues();
    var fieldValue = scor.utils.trim(dialogValue.field.value);
    var criteriaValue = dialogValue.criteria.value;

    if (onOkClick === true) {
        if (isValid && fieldValue === '') {
            isValid = false;
            msg = "${valFilterEmpty}";
        }

        if (isValid && isExist(fieldValue, criteriaValue, list)) {
            isValid = false;
            msg = "${valRegFilterDuplicate}";
        }
    }
    if (isValid) {
        isValidObj = isRegistryValid(fieldValue, '${orion:escapeJavaScriptString(param.osType)}');
    }
    if (isValidObj) {
        isValid = isValidObj.isValid;
        msg = isValidObj.msg;
    }

    handleError(isValid, msg);
    OrionCore.enableDialogBoxOkButton(isValid);

    return isValid;
}

function isRegistryValid(fieldValue, os) {

    var re;
    var isValid = true;
    var msg = "";

    re = new RegExp("((.\\*)$)|((.\\*\\\\)$)", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valRegFilternoStarAtEnd}";
    }

    re = new RegExp("([^\\\\]\\*)", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valRegFilternoStarInBetwn}";
    }

    re = new RegExp("(\\*[^\\\\])", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valRegFilternoStarInBetwn}";
    }

    re = /^(HKEY_CLASSES_ROOT|HKEY_CURRENT_CONFIG|HKEY_CURRENT_USER|HKEY_LOCAL_MACHINE|HKEY_USERS|\\REGISTRY)/i;
    if (isValid && !re.test(fieldValue)) {
        isValid = false;
        msg = "${valRegFilterMustBeginWith}";
    }
    return {'isValid': isValid, 'msg': msg};

}


function isExist(fieldValue, criteriaValue, list)
{
    var rows = list.getRows();
    for (var rowKey in rows)
    {
        var row = rows[rowKey];
        if (row != null && row != undefined)
        {
            var existFieldValue = scor.utils.trim(row['field']);
            var existCriteriaValue = scor.utils.trim(row['filter']);
            if ((existFieldValue === fieldValue) && (existCriteriaValue === criteriaValue))
                return true;
        }
    }
    return false;
}



function getProfileUnitVOArray(list)
{
    var vo = [];

    var rows = list.getRows();
    for (var rowKey in rows)
    {
        var row = rows[rowKey];
        if (row != null && row != undefined)
        {
            var field = OrionCore.trim(row['field']);
            var filter = ( OrionCore.trim(row['filter'].toLowerCase()) === "Include".toLowerCase() ? "include" : "exclude")
            var profileUnitVO = scor.vos.profile.ProfileUnitVO(field, filter);
            vo.push(profileUnitVO.common.getVO());

        }
    }

    return vo;

}
var fillListfromVO = function (obj, list)
{
    //obj expects a Array of  scor.vos.profile.ProfileUnitVO
    //scor.utils.clearMagicListWidget(list);

    obj = obj ? obj : {}
    for (var i = 0; i < obj.length; i++)
    {
        var field = obj[i].getField();
        var filter = obj[i].getFilter();
        var newObj = {"field" : field, "filter" : (filter.toLowerCase() === "Include".toLowerCase() ? "Include" : "Exclude") }
        list.insert(newObj);
    }

}

/**
 * Fix for IE.
 * The popup panel doesn't set any radio button to checked in when we click ADD button
 * To fix this, we will check if none is checked,
 * check "Include" (but for Users - select "Exclude" as "Include" is disabled)
 */
function setRadioButtonAndCheckBox() {
    var dialogNode = OrionCore.getDialogBoxContainer();
    var children = dialogNode.getElementsByTagName("input");
    var includeRadio;
    var excludeRadio;
    for (var i = 0; i < children.length; i++) {
        if (children[i].type && children[i].type == "radio") {
            if (children[i].value == "Include") {
                includeRadio = children[i];
            } else if (children[i].value == "Exclude") {
                excludeRadio = children[i];
            }
        }

    }
    if (includeRadio && excludeRadio) {
        if (includeRadio.disabled) {
            excludeRadio.checked = true;
        } else {
            if (!excludeRadio.checked && !includeRadio.checked) {
                includeRadio.checked = true;
            }
        }
    }
}

function isRpPathFilterValid() {
    var dialogValue = getDialogBoxFilterValues();
    var fieldValue = scor.utils.trim(dialogValue.field.value);
    var criteriaValue = dialogValue.criteria.value;

    var isValid = !isExist(fieldValue, criteriaValue, rppathFilterList);

    $("error_include").style.display = (isValid ? "none" : "block");

    return isValid;
}

function myEpoEnableApplyButton() {
    if (typeof epoEnableApplyButton === 'function') {
        epoEnableApplyButton();
    }
}

function myEpoDisableApplyButton() {
    if (typeof epoDisableApplyButton === 'function') {
    	epoDisableApplyButton();
    }
}

// Validation
var isUserFilterValid = function (onOkClick, os, list) {
    var isValid = true;
    var msg = "";
    var isValidObj;

    var dialogValue = getDialogBoxFilterValues();
    var fieldValue = scor.utils.trim(dialogValue.field.value);
    var criteriaValue = dialogValue.criteria.value;

    if (onOkClick === true) {
        if (isValid && fieldValue === '') {
            isValid = false;
            msg = "${valFilterEmpty}";
        }

        if (isValid && isExist(fieldValue, criteriaValue, list)) {
            isValid = false;
            msg = "${valUserFilterDuplicate}";
        }
    }

    if (isValid) {
        isValidObj = isUserValid(fieldValue, '${orion:escapeJavaScriptString(param.osType)}');
    }

    if (isValidObj) {
        isValid = isValidObj.isValid;
        msg = isValidObj.msg;
    }

    handleError(isValid, msg);
    OrionCore.enableDialogBoxOkButton(isValid);

    return isValid;
}

function isUserValid(fieldValue, os) {

    var re;
    var isValid = true;
    var msg = "";

    if (os === "<%=PolicyConstants.POLICY_OS.UNIX.getValue()%>") {
        if(fieldValue.indexOf("\\") > 0  || fieldValue.indexOf("\\") === 0 || fieldValue.indexOf("/") > 0 || fieldValue.indexOf("/") === 0){
            isValid = false;
            msg = "${valUserCharNotAllowedUnix}";
        }
    }
    re = new RegExp("[/\\*]", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valUserCharNotAllowed}";
    }

    re = new RegExp("([\\\\]).*([\\\\])", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valUseronlySingleSlash}";
    }

    return {'isValid': isValid, 'msg': msg};

}

var isExtensionFilterValid = function (onOkClick, os, list) {
    var isValid = true;
    var msg = "";
    var re;
    var isValidObj;

    var dialogValue = getDialogBoxFilterValues();
    var fieldValue = scor.utils.trim(dialogValue.field.value);
    var criteriaValue = dialogValue.criteria.value;

    if (onOkClick === true) {
        if (isValid && fieldValue === '') {
            isValid = false;
            msg = "${valFilterEmpty}";
        }
        if (isValid && isExist(fieldValue, criteriaValue, list)) {
            isValid = false;
            msg = "${valExtnFilterDuplicate}";
        }
    }

    if (isValid) {
        isValidObj = isExtensionValid(fieldValue, '${orion:escapeJavaScriptString(param.osType)}');
    }

    if (isValidObj) {
        isValid = isValidObj.isValid;
        msg = isValidObj.msg;
    }

    handleError(isValid, msg);
    OrionCore.enableDialogBoxOkButton(isValid);

    return isValid;
}

function isExtensionValid(fieldValue, os) {

    var re;
    var isValid = true;
    var msg = "";

    re = new RegExp("[\\-]", "");
    if (isValid && re.test(fieldValue)) {
        isValid = false;
        msg = "${valExtnCharNotAllowed}";
    }

    return {'isValid': isValid, 'msg': msg};

}


var isProcessFilterValid = function (onOkClick, os, list) {
    var isValid = true;
    var msg = "";
    var re;

    var dialogValue = getDialogBoxFilterValues();
    var fieldValue = scor.utils.trim(dialogValue.field.value);
    var criteriaValue = dialogValue.criteria.value;

    // doing only empty and duplicate check here
    if (onOkClick === true) {
        if (isValid && fieldValue === '') {
            isValid = false;
            msg = "${valFilterEmpty}";
        }

        if (isValid && isExist(fieldValue, criteriaValue, list)) {
            isValid = false;
            msg = "${valProgramFilterDuplicate}";
        }
    }


    handleError(isValid, msg);
    OrionCore.enableDialogBoxOkButton(isValid);

    return isValid;
}

function isProcessValid(fieldValue, os) {

    var re;
    var isValid = true;
    var msg = "";

    return {'isValid': isValid, 'msg': msg};

}

</SCRIPT>

<div id="rp_path_filter_editor_template" style="display:none;">
    <c:if test="${param.osType == WIN_OS}">
        <orion:message key="policy.mon.file.msg" escape="html"/>
    </c:if>
    <c:if test="${param.osType == UNIX_OS}">
        <orion:message key="policy.mon.unix.file.msg" escape="html"/>
    </c:if>

    <table width="100%">
        <tr>
            <td width="25%" align="left">${file}:</td>
            <td width="75%">
                <orion:textbox id="field" required="true" maxlength="1024"/>
            </td>
        </tr>
        <tr>
            <td width="25%"></td>
            <td width="75%">
                <input type="radio" name="filter" id="filter" value="Include" checked onclick="scor.common.changeInputId('filter', rp_path_filter_editor_template);"/>
                <label class="styledCheckbox" for="filter" id="filter_include_label">   
                    ${include}
                </label>                
                <input type="radio" name="filter" id="filterExclude" value="Exclude" onclick="scor.common.changeInputId('filter', rp_path_filter_editor_template);"/>
                <label class="styledCheckbox" for="filterExclude" id="filter_exclude_label">     
                    ${exclude}
                </label>
            </td>
        </tr>

    </table>
    <div id="error_include" style="display:none;color:red;">
    </div>
     <div id="scor_warningDiv" class="scorWarning" style="display:none;"></div>
  
</div>


<div id="registry_filter_editor_template" style="display:none;">
    <orion:message key="policy.mon.reg.msg" escape="html"/>
    <table width="100%">
        <tr>
            <td width="25%" align="left">${registry}:</td>
            <td width="75%">
                <orion:textbox id="field" required="true" maxlength="255"/>
            </td>
        </tr>
        <tr>
            <td width="25%"></td>
            <td width="75%">
                <input type="radio" name="filter" id="filter" value="Include" checked onclick="scor.common.changeInputId('filter', registry_filter_editor_template);"/>
                <label class="styledCheckbox" for="filter" id="filter_include_label">   
                    ${include}
                </label>                
                <input type="radio" name="filter" id="filterExclude" value="Exclude" onclick="scor.common.changeInputId('filter', registry_filter_editor_template);"/>
                <label class="styledCheckbox" for="filterExclude" id="filter_exclude_label">     
                    ${exclude}
                </label>
            </td>
        </tr>

    </table>
    <div id="error_include" style="display:none;color:red;">
    </div>
    <div id="scor_warningDiv" class="scorWarning" style="display:none;"></div>
   
</div>

<div id="filter_list_row_template" style="display:none;">
    <table cellspacing='0' cellpadding='0' width='100%' style="table-layout: fixed" >
        <tr>
            <td width='10%' class="scorWordWrap">
                @filter
            </td>
            <td width='90%' class="scorWordWrap">
                @field
            </td>
        </tr>
    </table>
</div>

