<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<orion:script context="/core" src="/majic.js" />
<jsp:include page="./PathFilters.jsp" />
<style type="text/css">
.scorMonPolicyTextArea {
	overflow:auto; 
	resize: none;
	font-size: 11px;
    line-height: 15px;
	}	
	
.scorMonPolicyHelpTextArea {
	font-size: 11px;
	font-style:italic;
	color: grey;
	}
.scorMonPolicyErrorDiv {
	display: none; 
	color: red;
	}
	
</style>

<orion:message key="policy.mon.include" var="include" escape="html" />
<orion:message key="policy.mon.exclude" var="exclude" escape="html" />
<orion:message key="policy.mon.filter" var="filter" escape="none" />
<orion:message key="policy.mon.filters" var="filters" escape="none" />
<orion:message key="scor.policy.mon.file" var="file" escape="html" />
<orion:message key="scor.policy.mon.enableFileTracking"
	var="enableFileTracking" escape="html" />
<orion:message key="policy.mon.file.fileDiff.enable" var="fileDiffEnable" escape="none" />
<orion:message key="scor.policy.mon.isDirectory" var="isDirectoryVar" escape="none" />
<orion:message key="scor.policy.mon.recurseDir" var="recurseDirVar" escape="none" />
<orion:message key="scor.policy.mon.includePatterns" var="includePatternsVar" escape="html" />
<orion:message key="scor.policy.mon.excludePatterns" var="excludePatternsVar" escape="html" />
<orion:message key="scor.policy.mon.patternBox.defaultMessage" var="patternBoxDefaultMsg" escape="html" />

<orion:box id="WinIdPathFilter">
	<table cellspacing="0" cellpadding="0" width="98%">
		<%@ include file="../AdjustOtherTabs.jsp"%>
		<tr>
			<td class="orionSummaryColumn">
			<table cellspacing='3' cellpadding='0' width='720px'>
				<tr>
					<td width="10%" align="left"><b><orion:message key="${filter}" escape="html" /></b></td>
					<td width="40%" align="left"><b><orion:message key="policy.mon.path" escape="html" /></b></td>
					<td width="20%" align="left"><b><orion:message key="policy.mon.file.trackingSettings" escape="html" /></b></td>
					<td width="15%" align="left"><b><orion:message key="scor.policy.mon.includePatterns" escape="html" /></b></td>
					<td width="15%" align="left"><b><orion:message key="scor.policy.mon.excludePatterns" escape="html" /></b></td>
				</tr>
			</table>
			<orion:box id="idPathFilterList" height="auto" width="720" /></td>
		</tr>
	</table>

	<div id="filter_list_row_template_for_mon_file" style="display: none;">
	<table cellspacing='0' cellpadding='0' width='100%'
		style="table-layout: fixed">
		<tr>
			<td width='10%' class="scorWordWrap">@filter</td>
			<td width='40%' class="scorWordWrap">@field</td>
			<td width='20%'>@fileTrackingSettings</td>
			<td width='15%' class="scorWordWrap">@formattedIncludePatterns</td>
			<td width='15%' class="scorWordWrap">@formattedExcludePatterns</td>
			<td width="0%" style="display: none;" >@fileTracking</td>
			<td width="0%" style="display: none;">@isDirectory</td>
			<td width="0%" style="display: none;">@isRecurse</td>
			<td width="0%" style="display: none;">@fileEncodingKey</td>
			<td width="0%" style="display: none;">@fileEncodingLocalizedKey</td>
			<td width='0%' style="display: none;">@includePatterns</td>
			<td width='0%' style="display: none;">@excludePatterns</td>

		</tr>
	</table>
	</div>

	<div id="path_filter_editor_template" style="display: none;">
		<orion:message key="policy.mon.file.msg" escape="html" />

		<table width="100%">
			<tr>
				<td width="25%" align="left">${file}:</td>
				<td width="75%"><orion:textbox id="field" required="true" maxlength="1024" /></td>
			</tr>
			<tr>
				<td width="25%"></td>
				<td width="75%"><label> <input type="radio" name="filter" id="filter" value="Include" CHECKED="true" />
				${include} </label> <label> <input type="radio" name="filter" id="filter" value="Exclude" /> ${exclude} </label></td>
			</tr>
		</table>
		<div id="error_include" class="scorMonPolicyErrorDiv"></div>
		<orion:vbox>
			<orion:hbox>
				<orion:checkbox id="fileTrackingCkBox" text="${fileDiffEnable}" onclick="scor.mon.file.validatePathForFD();" />
			</orion:hbox>
			<br>
			<orion:hbox>
				<orion:message key="policy.mon.file.fileDiff.fileEncoding" escape="html" />
				<orion:select id="selectFileEncoding" items="${fileEncodingSelectBeans}" />
			</orion:hbox>
			<br>
			<orion:hbox>
				<orion:checkbox id="isDirectory" text="${isDirectoryVar}" onclick="scor.mon.file.enableDisableDirElements();" />
				<orion:checkbox id="recurseDir" text="${recurseDirVar}" />
			</orion:hbox>
			<br>
			<table width="100%">
				<tr>
					<td width="25%" align="left">${includePatternsVar}:</td>
					<td width="55%">
						<textarea id="includePattern" rows="3" cols="40" class="scorMonPolicyTextArea" >${patternBoxDefaultMsg}</textarea>
					</td>
					<td width="20%">
						<div id="includePatternErrorDiv" class="scorMonPolicyErrorDiv"></div>
					</td>
				</tr>
				<tr>
					<td width="25%" align="left">${excludePatternsVar}:</td>
					<td width="55%"><textarea id="excludePattern" rows="3" cols="40" class="scorMonPolicyTextArea">${patternBoxDefaultMsg}</textarea></td>
					<td width="20%">
						<div id="excludePatternErrorDiv" class="scorMonPolicyErrorDiv"></div>
					</td>
				</tr>
			</table>
		</orion:vbox>
	</div>
</orion:box>

<script type="text/javascript">
var monWinPathFilterList = new majic.ListWidget({
    container: "idPathFilterList",
    width: "720px",
    height: "320px",
    addCallback: pathAddCallback,
    editCallback: pathEditCallback,
    removeCallback: myEpoEnableApplyButton,
    buttons: {
        'add': '<orion:message key="policy.mon.button.add"   escape="javascript"/>',
        'edit': '<orion:message key="policy.mon.button.edit"   escape="javascript"/>',
        'remove': '<orion:message key="policy.mon.button.remove"   escape="javascript"/>'
    },
    content: $('path_filter_editor_template').innerHTML,
    displayText: $('filter_list_row_template_for_mon_file').innerHTML,
	formatCallback: listWidgetformatCallback 
});

</script>