<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.mcafee.scor.observationmode.ObservationStatisticsConstants"%>
<%@page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<jsp:include page="/common/includejQuery.jsp" />


<orion:message key="scor.observationstats.excludeObservations.dialog.title" var="excludeObsTitle" escape="javascript" />
<orion:message key="scor.observationstats.approveObservations.dialog.title" var="approveObsTitle" escape="javascript" />
<orion:message key="scor.observationstats.addRuleToGlobalFilterGroup" var="addRuleToGlobalFilterGroup" escape="html"/>
<orion:message key="scor.observationstats.defaultDeleteMessage" var="defaultDeleteMessage" escape="html"/>
<orion:message key="scor.observationstats.excludeObservations.purgeObservations" var="purgeObservations" escape="html"/>
<orion:message key="scor.observationstats.excludeObservations.noNeedToCreateObsFilter" var="noNeedToCreateObsFilter" escape="html"/>
<orion:message key="scor.observationstats.excludeObservations.note" var="noteVarJS" escape="javascript"/>
<orion:message key="scor.observations.stats.table.title" var="predominantObservationsTitleText" escape="none"/>




<script type="text/javascript">
OrionHelp.setHelpId("<%=HelpConstants.OBSERVATIONS_STATS_PAGE%>");
var scor = scor || {};
scor.observations = scor.observations || {};
scor.observations.stat = scor.observations.stat ||{};
scor.observations.stat.uid  = scor.observations.stat.uid || 0;

OrionCore.addLoadHandler(scorObservationsStatInit);

function scorObservationsStatInit(){
	statsTable = MFSTable.get("scorObserationStatsTable");
	statsTable.setOnStateChange( scor.observations.stat.setApproveCustomSuggestionActionStatus );
}

scor.observations.stat.setApproveCustomSuggestionActionStatus = function() {
	 var selectedUids = statsTable.getSelected().split(",");	 
	 var approveCustomSuggestionActionIndex = scor.observations.stat.getActionIndexByURLInActionTab("showStatSuggestion.do");    
	 if(selectedUids.length > 1){
		 OrionAction.actionList[approveCustomSuggestionActionIndex].disabled = true;
         return;
	}
	 if(approveCustomSuggestionActionIndex === -1){
		 return;
	 }
     for(var k in selectedUids){
       if (selectedUids[k] === "") {
            continue;
       }
       var selectedTableRow = $j('tr[uid='+selectedUids[k]+']');
       var approveSuggestionLinksPresent = $j(selectedTableRow).find('.showApproveClass');
       if (approveSuggestionLinksPresent.length == 0) {
          OrionAction.actionList[approveCustomSuggestionActionIndex].disabled = true;
          return;
        }
        OrionAction.actionList[approveCustomSuggestionActionIndex].disabled = false;
    }    
}

scor.observations.stat.getActionIndexByURLInActionTab = function(url) {
    var scorPredominantTableActionIndex = -1;
	for(var j in OrionAction.actionList){
        if(OrionAction.actionList[j].actionURI.indexOf(url) != -1){
        	scorPredominantTableActionIndex = j;
        	break;
        }
    }
    return scorPredominantTableActionIndex;
}

scor.observations.refreshObsStatsTable = function() {	
	statsTable.clearSelection();
	statsTable.refresh();
}


scor.observations.approveObservations = function (uid) {
	scor.observations.stat.uid = uid;
	var paramMap = ['<%=ObservationStatisticsConstants.OBSERVATION_STATS_AUTO_ID%>', scor.observations.stat.uid]; 
	scor.actions.doAsyncAction ('<%=URLConstants.APPROVE_OBSERVATIONS_GET_MESSAGE_URL%>', paramMap, scor.observations.approveObservationDialogBox, null, "POST");
}

scor.observations.approveObservationDialogBox =function(result){		
	if(result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_APPROVE_ACTION_NEEDED_ATTR%>'] === 'true'){
		var rootDiv = $j('#approveDialogBox');
		
		var divForApprovalMessage = $j(rootDiv).find('#approveMessage');
		var msg = result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_APPROVE_MESSAGE_ATTR%>'];
		var msgAddRuleToGlobalFilterGroup  = $j('div#addRuleToGlobalFilterGroup').html();
		var completeMsg = msg+ " "+ msgAddRuleToGlobalFilterGroup;
		$j(divForApprovalMessage).html("");
		$j(divForApprovalMessage).html(completeMsg);
		
		OrionCore.showDialogBox(true, $('approveDialogBox').innerHTML, OrionCore.DIALOG_OK_CANCEL);
		OrionCore.setDialogBoxTitle('${approveObsTitle}');
		OrionCore.dialogBoxOkHandler = scor.observations.approveObservationsDialogBoxOkHandler;	
	}else{
    	scor.observations.createNoActionNeededDialogBox('${approveObsTitle}');
	}
}


scor.observations.approveObservationsDialogBoxOkHandler = function(){
	 var paramMap = ['<%=ObservationStatisticsConstants.OBSERVATION_STATS_AUTO_ID%>', scor.observations.stat.uid]; 
	 scor.actions.doAsyncAction ('<%=URLConstants.APPROVE_OBSERVATIONS_USING_STATS_URL%>', paramMap, scor.observations.refreshObsStatsTable, null, "POST");
}


scor.observations.excludeObservations = function (uid) { 
	scor.observations.stat.uid = uid;
	var paramMap = ['<%=ObservationStatisticsConstants.OBSERVATION_STATS_AUTO_ID%>', scor.observations.stat.uid];
	scor.actions.doAsyncAction ('<%=URLConstants.EXCLUDE_OBSERVATIONS_GET_EXCLUSION_MESSAGE_URL%>', paramMap, scor.observations.excludeObservationDialogBox, null, "POST");
	
};


scor.observations.excludeObservationDialogBox =function(result){		
	if(result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_ACTION_NEEDED_ATTR%>'] === 'true'){
		var rootDiv = $j('#excludeWarningMessage');
		
		var divForExclusionMessage = $j(rootDiv).find('#exclusionMessage');
		var msg = result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_CONFIRM_EXCLUSION_MESSAGE_ATTR%>'];
		var msgAddRuleToGlobalFilterGroup  = $j('div#addRuleToGlobalFilterGroup').html();
		var completeExclusionMsg = msg+ " "+ msgAddRuleToGlobalFilterGroup;
		$j(divForExclusionMessage).html("");
		$j(divForExclusionMessage).html(completeExclusionMsg);
		
		var divForWarningMessageForGenericPRocess = $j(rootDiv).find('#warningMessageForGenericProcess');
		var msgForGeneric = result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_CRITICAL_PROCESS_WARNING_MESSAGE_ATTR%>']
		if(msgForGeneric !== ""){
			$j(divForWarningMessageForGenericPRocess).show().html("<b>${noteVarJS}: &nbsp;</b>"+msgForGeneric);
		}else{
			$j(divForWarningMessageForGenericPRocess).hide().html("");
		}
		
		OrionCore.showDialogBox(true, $('excludeWarningMessage').innerHTML, OrionCore.DIALOG_OK_CANCEL);
    	OrionCore.setDialogBoxTitle('${excludeObsTitle}');
    	OrionCore.dialogBoxOkHandler = scor.observations.excludeWarningDialogBoxOkHandler;	
	}else{
		scor.observations.createNoActionNeededDialogBox('${excludeObsTitle}');
	}
}

scor.observations.excludeWarningDialogBoxOkHandler = function(){	
	 var paramMap = ['<%=ObservationStatisticsConstants.OBSERVATION_STATS_AUTO_ID%>', scor.observations.stat.uid]; 
	 scor.actions.doAsyncAction ('<%=URLConstants.EXCLUDE_OBSERVATIONS_USING_STATS_URL%>', paramMap, scor.observations.refreshObsStatsTable, null, "POST"); 
}

scor.observations.createNoActionNeededDialogBox = function(dialogBoxTitle){
	var rootDiv = $j('#noActionNeededDiv');		
	var divForMessage = $j(rootDiv).find('#noActionNeededMessage');
	var msg = result['<%=ObservationStatisticsConstants.OBSERVATION_STATS_CONFIRM_EXCLUSION_MESSAGE_ATTR%>']
	$j(divForMessage).html(msg);
	OrionCore.showDialogBox(true, $('noActionNeededDiv').innerHTML, OrionCore.DIALOG_OK);
	OrionCore.setDialogBoxTitle(dialogBoxTitle);
	OrionCore.dialogBoxOkHandler = scor.observations.excludeWarningDialogBoxOkHandler;	
}

</script>

<orion:vbox>
	<orion:table2 id="scorObserationStatsTable"
		registeredTypeUID="scor.rt.predominantObservations.uid"
		showTitleBar="false"
		cellRendererAttr="<%=ObservationStatisticsConstants.OBSERVATION_STATS_CELLRENDERER_ATTR%>"
		datasourceAttr="<%=ObservationStatisticsConstants.OBSERVATION_STATS_DATASOURCE_ATTR%>"
		allowConfiguration="true" allowExport="true" enableDrilldown="false"
		allowAdvancedFilter="false" columnWidths="30,30,20,10,20"
		properties="parentProcessName,binaryName,observationType,count,actions" />
</orion:vbox>


<div id="excludeWarningMessage" style="display:none;">
	<div id="exclusionMessage"></div><br>
	<div id="addRuleToGlobalFilterGroup"  style="display:none;">${addRuleToGlobalFilterGroup}</div>
	<div id="defaultDeleteMessage">${defaultDeleteMessage}</div><br>
	<div id="warningMessageForGenericProcess" style="display:none;"></div><br>
</div>

<div id="approveDialogBox" style="display:none;">
	<div id="approveMessage"></div><br></br>
	<div id="addRuleToGlobalFilterGroup" style="display:none;">${addRuleToGlobalFilterGroup}</div>
	<div id="defaultDeleteMessage">${defaultDeleteMessage}</div><br>
</div>


<div id="noActionNeededDiv" style="display:none;">
	<div id="noActionNeededMessage"></div><br><br>
</div>
