<%-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>

<orion:core>
    <orion:corehead>
    	<jsp:include page="/common/includejQuery.jsp" />
        <script type="text/javascript">
      
            function editRuleGroupOwnershipOnLoad(){
                editRuleGroupOwnershipToggleSaveBtn();
            };

            function editRuleGroupOwnershipCancel()
            {
                OrionForm.rescan();
                OrionNavigation.lastAnchorPage();
            };

            function editRuleGroupOwnershipSave(){
                 OrionCore.doFormAction("/SOLIDCORE_META/saveRuleGroupOwnership.do", ["ruleGroupId", ${ruleGroupId}], 'POST');
            };

            function editRuleGroupOwnershipToggleSaveBtn()
            {
                OrionCore.setEnabledById("saveGroup", false);

                for(var i=0; i<$("inputhiddenID_NumUsers").value; i++)
                {
                    if($("checkBoxId_" + i).checked)
                        OrionCore.setEnabledById("saveGroup", true);
                } 
            };
        </script>
    </orion:corehead>
    <orion:corebody onload="editRuleGroupOwnershipOnLoad()">
     <orion:navigation />
        <orion:content>
            <orion:vbox>
            	<orion:message var="editRuleGroupOwnershipCancel" key="scor.cancel.button.txt" escape="none"/>
            	<orion:message var="editRuleGroupOwnershipSave" key="scor.save.button.txt" escape="none"/>
                <orion:message var="ruleGroupText" key="scor.rulegroup.ownership.for" escape="none"/>
				<orion:titlebar text="${ruleGroupText} ${ruleGroupType} > ${ruleGroupPlatform} > ${ruleGroupName}"/>
                <orion:box height="auto">
                    <c:if test="${noPermission== 'true'}">
                        <span style="color:red"><orion:message key="scor.ruleGroupOwnership.noPermission" params="${noPermissionUsers}" /></span>
                    </c:if> 

                    <div style="height:100%;width:100%;overflow:auto">
                        <table>
                            <c:set var="iIndex" scope="page" value="0" />
                            <c:forEach var="orionUser" items="${listOrionUsers}">
                                <tr>
                                    <td>
                                        <c:set var="checkedOrionUser" scope="page" value="checkedUser${orionUser.id}" />
                                        <c:set var="disabledOrionUser" scope="page" value="disabledUser${orionUser.id}" />
                                        <orion:checkbox
                                            id="checkBoxId_${iIndex}"
                                            name="checkBoxUser_${iIndex}"
                                            checked="${orion:find(checkedOrionUser, pageContext)}"
                                            onclick="editRuleGroupOwnershipToggleSaveBtn()"
                                            disabled="${orion:find(disabledOrionUser, pageContext)}"
                                            text="${orionUser.name}"/>
                                        <input type="hidden" name="hiddenUserId_${iIndex}" value="${orionUser.id}"/>
                                    </td>
                                </tr>
                                <c:set var="iIndex" value="${iIndex + 1}" />
                            </c:forEach>
                        </table>
                    </div>
                </orion:box>
               <orion:footerbar>				
					<orion:button id="saveGroup" text="${editRuleGroupOwnershipSave}" onclick="editRuleGroupOwnershipSave();" />
					<orion:button id="cancelGroup" text="${editRuleGroupOwnershipCancel}" onclick="editRuleGroupOwnershipCancel();" />
				</orion:footerbar>
            </orion:vbox>
  			</orion:content>
        <input type="hidden" id="inputhiddenID_NumUsers" name="numUsers" value="${numUsers}"/>
    </orion:corebody>
</orion:core>