<%--
//-----------------------------------------------------------------------------
// Copyright (c) 2011-2012 XEROX Corporation.  All rights reserved
//-----------------------------------------------------------------------------
// Revision History:
// -----------------
// AR Number      Author   Date         Change Description
// ---------      ------   ----         ------------------
//
// CQGbl00349040  bvu      01/04/2012   Created       
//-----------------------------------------------------------------------------
--%>

<%--
  This is the view for the Browser tab on the Software Update page.

  This is part of the McAfee tab layout.
--%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>


<orion:vbox>

  <orion:box height="10"/>

  <orion:hbox height="90">

    <orion:box width="460">

       <br/>
       &nbsp;&nbsp;<orion:message key="XeroxMFP.systemSoftwareUpdate.notice" /><br/><br/>
         
       &nbsp;
        <orion:select style="width:320px;" id="firmwareSelect" items="${firmwareList}"/>

    </orion:box>
   
    <orion:hbox>
      <orion:box width="26"/> 
      <orion:box width="14" background="#f2f2f2"/> 
      <orion:box width="500" background="#f2f2f2">

      	<table background="#f2f2f2">
          <tr>
            <td>
              <b>
                <orion:message key="XeroxMFP.systemSoftwareUpdate.selectFromExisting.notes.label"/>:&nbsp;
              </b>
              <orion:message key="XeroxMFP.systemSoftwareUpdate.selectFromExisting.notes.message"/>
            </td>
          </tr>
        </table>

    </orion:box>

    <orion:box width="10" background="#f2f2f2"/> 

    <orion:box width="auto"/> 

    </orion:hbox>

  </orion:hbox>
	    
  <orion:box width="10"/>
  <orion:box height="auto">


    <table id="selectedDeviceTable" width="99%" align="center" cellspacing="0">


      <tr>
        <td class="orionSummaryHeader" width="25%">
          <orion:message key="XeroxMFP.deviceName"/>
        </td>
        <td class="orionSummaryHeader" width="25%">
          <orion:message key="XeroxMFP.status"/>
        </td>
        <td class="orionSummaryHeader" width="25%">
          <orion:message key="XeroxMFP.ip"/>
        </td>
        <td class="orionSummaryHeader" width="25%">
          <orion:message key="XeroxMFP.deviceModel"/>
        </td>
      </tr>

      <c:forEach items="${selectedDevices}" var="d">
      <tr>
        <td class="orionSummaryColumn" width="25%" style="border-right: 1px solid #E1E1E1;border-left: 1px solid #E1E1E1;">${orion:escapeHtml(d.deviceName)}</td>
        <td class="orionSummaryColumn" width="25%" style="border-right: 1px solid #E1E1E1;">${orion:escapeHtml(d.status)}</td>
        <td class="orionSummaryColumn" width="25%" style="border-right: 1px solid #E1E1E1;">${orion:escapeHtml(d.ip)}</td>
        <td class="orionSummaryColumn" width="25%" style="border-right: 1px solid #E1E1E1;">${orion:escapeHtml(d.deviceModel)}</td>
      </tr>
      </c:forEach>


    </table>

  </orion:box>

  <orion:box height="32">

    <orion:footerbar>
      <orion:message key="XeroxMFP.label.ok" escape="none" var="okLabel" /> 
      <orion:button id="ok" onclick="updateFromServer();" text="${okLabel}" disabled="true"/>
      <orion:message key="XeroxMFP.label.cancel" escape="none" var="cancelLabel" /> 
      <orion:button id="cancel" onclick="backToExtensionHome();" text="${cancelLabel}"/>
                
    </orion:footerbar>
  </orion:box>

</orion:vbox>
