<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<orion:message var="testButton" key="syslog.text.test.connection" escape="none" />

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.SYSLOG_REG_SERVER_PAGE%>");
</script>

<script type="text/javascript">
    function validate()
    {
        OrionCore.focusOn("serverName");
        OrionForm.setValidateHandler(_onPageValidate);
    }

    function validateDNSName(string)
    {
        var invalidChars = "\\`~!@#$%^&*()_=+{}[]|;:'?\",/<>";
        var valid =  OrionValidate.isNotEmpty( string );
        if(valid)
        {
            for ( var i = 0; i < string.length; ++i )
            {   var c = string.charAt(i);
                if ( invalidChars.indexOf(c) >= 0 )
                {
                    valid = false;
                    break;
                }
            }
        }
        return valid;
    }

    function serverAddressValidation ()
    {
        var srvrType = $("addrType").value;

        // Valid string is HOST/PORT.
        var host = $("addr").value;
        var n = host.lastIndexOf('/');
        if (n >= 0)
        {
            // Validate PORT.
            if (n == host.length - 1)
            {
                return false;
            }
            var port = host.substring(n + 1);
            for (var i = 0; i < port.length; ++i)
            {
                var c = port.charAt(i);
                if (c < '0' || c > '9')
                {
                    return false;
                }
            }
            if (!OrionValidate.isIntBetween(port, 0, 65535))
            {
                return false;
            }

            host = host.substring(0, n);
        }

        if ( srvrType == "hostName" )
        {
            return validateDNSName(host);
        }
        else if ( srvrType == "ipv4addr" )
        {
            return OrionValidate.isValidIPv4String(host);
        }
        else if ( srvrType == "ipv6addr" )
        {
            return OrionValidate.isValidIPv6String(host);
        }
    }

    function testSyslogServer()
    {
         OrionCore.showPleaseWait(true);

         var addrType = $("addrType").value;
         var addr = $("addr").value;
         var parms = new Array();
         var i = 0;
         parms[i++] = 'addr';
         parms[i++] = addr;
         parms[i++] = 'addrType';
         parms[i++] = addrType;

        $('tdUnReachable').style.display="none";
        $('tdUnknown').style.display="none";
        $('tdSuccess').style.display="none";
//        $('messages').style.display="none";

         OrionCore.doAsyncAction("/SOLIDCORE_META/testaddr.do", parms, fnAfterTest, null, "GET");
    }
    function fnAfterTest(text)
    {
         OrionCore.showPleaseWait(false);
//        $('messages').style.display="";
         if (text == 'unreachable') {
           $('tdUnReachable').style.display="";
         } else if (text == "unknown") {
           $('tdUnknown').style.display="";
         } else {
           $('tdSuccess').style.display="";
         }
    }

    function _onPageValidate(isValid)
    {
        if (isValid)
        {
            OrionCore.setEnabledById("testConnection", true);
        }
        else
        {
            OrionCore.setEnabledById("testConnection", false);
        }
    }
</script>

<table cellspacing="0" cellpadding="0" width="100%">
    <tr valign="top">
        <td class="orionSummaryHeader">
            <orion:message key="syslog.label.serverAddress"
                           escape="html" />
        </td>
        <td class="orionSummaryColumn">
            <orion:select id="addrType"
                name="addrType"
                items="${serverNameOption}"
                selected="${addrType}"/>
            <orion:textbox
                id="addr"
                name="addr"
                value="${addr}"
                size="75"
                length="75"
                maxlength="255"
                required="true"
                onvalidate="serverAddressValidation"  />
        </td>
    </tr>
    <tr id="tr_port">
        <td class="orionSummaryHeader">
            <orion:message key="syslog.label.port" escape="html"/>
        </td>
        <td class="orionSummaryColumn">
            <orion:numberbox id="syslogPort" name="port" maximum="65535" minimum="1" value="${port}" type="int" required="false"/>
        </td>
    </tr>
    <tr valign="top">
        <td class="orionSummaryHeader">
            <orion:message key="syslog.label.facility"
                           escape="html" />
        </td>
        <td class="orionSummaryColumn">
            <orion:select id="facility"
                name="facility"
                items="${facilityOptions}"
                selected="${facility}"/>
        </td>
    </tr>

    <tr valign="top">
        <td class="orionSummaryHeader">
            <orion:message  key="syslog.label.test"
                            escape="html" />
        </td>
        <td>
        <table cellspacing="0" cellpadding="0">
        <tr>
        <td class="orionSummaryColumn">
            <orion:button id="testConnection" text="${testButton}"
                          onclick="testSyslogServer();" />
            <span id="testResults"></span>
        </td>
        </tr>
        <tr id="messages"  class="orionSummaryColumn">
        <td id="tdUnReachable" class="orionSummaryHeader" style="display:none">
            <orion:message key="syslog.unreachable" escape="html"/>
        </td>
        <td id="tdSuccess" class="orionSummaryHeader" style="display:none">
            <orion:message key="syslog.reachable" escape="html"/>
        </td>
        <td id="tdUnknown" class="orionSummaryHeader" style="display:none">
            <orion:message key="syslog.unknown" escape="html"/>
        </td>
        </tr>
        </table>
        </td>

    </tr>

</table>
<script type="text/javascript">
 if (${portChangeSupported}) {
  $("tr_port").style.display='';
  }
  else {
  $("tr_port").style.display='none';
  }
</script>