<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="orion" uri="http://www.mcafee.com/orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<jsp:include page="/common/includejQuery.jsp"/>

<c:choose>
<c:when test="${isEpoVersionGreaterThanEqualTo5_0}">
	<orion:script context="/SOLIDCORE_META" src="/jsFiles/jquery/jquery-ui-1.11.4/jquery-ui.min.js"/>
	<orion:style context="/SOLIDCORE_META" url="/jsFiles/jquery/jquery-ui-1.11.4/jquery-ui.min.css" />
</c:when>
<c:otherwise>
	<!-- Do nothing. As, we do not support ePO older than 5.0 -->
</c:otherwise>
</c:choose>





<style>

.ui-corner-all { 
	-moz-border-radius: 0px;
	-webkit-border-radius: 0px;
	border-radius: 0px; 
}

.ui-widget-content .ui-state-hover {
	background: #ffffcc;
	color: #000000;
	border: 1px solid #ffffff

}

.ui-widget-content {
	background-color:#FFFFFF;
}
</style>


<%-- This sets up all the attributes, etc... --%>
${scor:autoCompleteTextBoxTagInit(pageContext)}
<c:set var="htmlId" value="${orion:escapeHtml(id)}"/>
<c:set var="url" value="${orion:escapeHtml(autoCompleteURL)}"/>
<c:set var="datasourceattr" value="${orion:escapeHtml(datasourceAttr)}"/>
<c:set var="minLength" value="${orion:escapeHtml(minLength)}"/>

	<orion:textbox id="${htmlId}" type="text"></orion:textbox>

<script type="text/javascript">
 


/**
 @constructor
 */
function ScorAutoComplete()
{
}
new ScorAutoComplete();

ScorAutoComplete.setFilter = function(datasourceattr, filter )
{
var args = new Array();
args.push("scorAutoCompleteFilter");
args.push(filter);
args.push("datasourceattr");
args.push(datasourceattr);
 
OrionCore.doAsyncAction("/SOLIDCORE_META/scorAutocompleteSetFilter.do", args, null, null);

}

$j(document).ready(

function () {
	var textBoxId="#"+"${htmlId}";
	var search_url="${url}"+"?"+"datasourceattr="+"${datasourceattr}" + scor.actions.getSecTokenParamLa();
	var minLength=${minLength};
	$j( textBoxId ).autocomplete({
			source: search_url,
			minLength: minLength
		
			
		}
		
		)

}


);

</script>



