<%-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved--%>
<%@ page import="com.mcafee.orion.core.OrionCore" %>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<orion:script context="/core" src="/majic.js"/>


<orion:message key="scor.task.server.imageDeviation.targetSystems" var="targetSystems" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.targetSystemGroups" var="targetSystemGroups" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.targetIncludedTags" var="targetIncludedTags" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.targetExcludedTags" var="targetExcludedTags" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.goldenSystem" var="goldenSystem" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.showInfoMsg" var="showInfoMsg" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.isBinaryPathCaseSensitive" var="isBinaryPathCaseSensitive" escape="html"/>
<orion:message key="scor.task.server.imageDeviation.system.dialogBoxText" var="systemDialogBoxText" escape="javascript"/>
<orion:message key="scor.task.server.imageDeviation.systemGroup.dialogBoxText" var="systemGroupDialogBoxText" escape="javascript"/>
<orion:message key="scor.task.server.imageDeviation.tag.dialogBoxText" var="tagDialogBoxText" escape="javascript"/>
<orion:message key="scor.task.server.imageDeviation.add" var="add" escape="none"/>
<orion:message key="scor.task.server.imageDeviation.remove" var="remove" escape="none"/>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.SERVER_TASK_RUN_IMAGE_DEVIATION%>");
</script>

<script type="text/javascript">

	var selectType;
	var TYPE_GOLD_SYSTEM = 0;
	var TYPE_SYSTEM =  1;
	var TYPE_GROUP = 2;
	var TYPE_INCLUDEDTAG = 3;
	var TYPE_EXCLUDEDTAG = 4;
	
	
	getSystemSingleVal_${orion:escapeJavaScriptString(parentIndex)} = function() {
		selectType = TYPE_GOLD_SYSTEM;
		OrionCore.setDialogBoxTitle('${systemDialogBoxText}');
		OrionCore.showAsyncDialogBox(true, "<%=URLConstants.LOAD_GOLD_SYSTEM_URL%>?parentIndex="+${orion:escapeJavaScriptString(parentIndex)}, null, setDialogSize);
		OrionCore.dialogBoxOkHandler = scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)};
	};

    getSystemMultipleVal_${orion:escapeJavaScriptString(parentIndex)} = function() {
        selectType = TYPE_SYSTEM;
        OrionCore.setDialogBoxTitle('${systemDialogBoxText}');
        OrionCore.showAsyncDialogBox(true, "<%=URLConstants.LOAD_SYSTEM_URL%>?parentIndex="+${orion:escapeJavaScriptString(parentIndex)}, null, setDialogSize);
        OrionCore.dialogBoxOkHandler = scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)};
    };

    getSystemGroups_${orion:escapeJavaScriptString(parentIndex)} = function() {
        selectType = TYPE_GROUP;
        OrionCore.setDialogBoxTitle('${systemGroupDialogBoxText}');
        OrionCore.showAsyncDialogBox(true, "<%=URLConstants.LOAD_SYSTEM_GROUP_URL%>?parentIndex="+${orion:escapeJavaScriptString(parentIndex)}, null, setDialogSize);
        OrionCore.dialogBoxOkHandler = scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)};
    };

    getIncludedTags_${orion:escapeJavaScriptString(parentIndex)} = function() {
        selectType = TYPE_INCLUDEDTAG;
        OrionCore.setDialogBoxTitle('${tagDialogBoxText}');
        OrionCore.showAsyncDialogBox(true, "<%=URLConstants.LOAD_INCLUDED_TAG_URL%>?parentIndex="+${orion:escapeJavaScriptString(parentIndex)}, null, setDialogSize);
        OrionCore.dialogBoxOkHandler = scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)};
    };

    getExcludedTags_${orion:escapeJavaScriptString(parentIndex)} = function() {
        selectType = TYPE_EXCLUDEDTAG;
        OrionCore.setDialogBoxTitle('${tagDialogBoxText}');
        OrionCore.showAsyncDialogBox(true, "<%=URLConstants.LOAD_EXCLUDED_TAG_URL%>?parentIndex="+${orion:escapeJavaScriptString(parentIndex)}, null, setDialogSize);
        OrionCore.dialogBoxOkHandler = scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)};
    };

    function setDialogSize(){
        scorSetDialogSize(400,600);
    };

    scanDialogBox = function() {
    	var tableId;
	 	switch (selectType) {
	 	case TYPE_GOLD_SYSTEM:
			tableId = 'imgDevGoldSystemTableD';
			break;
		case TYPE_SYSTEM:
			tableId = 'imgDevSystemsTableD';
			break;
		case TYPE_GROUP:
			tableId = 'imgDevSystemGroupsTableD';
			break;
		case TYPE_INCLUDEDTAG:
			tableId = 'imgDevIncludedTagsTableD';
			break;
		case TYPE_EXCLUDEDTAG:
			tableId = 'imgDevExcludedTagsTableD';
			break;
		}

		var selectedIds = ScorDialogTable.getSelectedUIDs(tableId);
		return selectedIds;
    };

    scorAddTargetDialogHandler_${orion:escapeJavaScriptString(parentIndex)} = function () {
        var result = scanDialogBox();
        if (result.length <= 0) {
            return;
        }
        var i = 0;
        switch (selectType) {
        case TYPE_GOLD_SYSTEM:
			var rowId = result[i];
			var rowData = ScorDialogTable.getRowData ('imgDevGoldSystemTableD', rowId);
			// The CellData format is exactly same as applied via formatCell() in CellRenderer
			// Cell Data format used in CR: <div>MACHINE_NAME</div><div style="display:none;">AGENT_GUID</div>
			var systemName = rowData[0].split("</div>")[0].split(">")[1];
			var agentGUID = rowData[0].split("</div>")[1].split(">")[1];

			var gold_system_txtBox = $('gold_system_${orion:escapeJavaScriptString(parentIndex)}');
			var gold_system_hid = $('gold_system_guid_${orion:escapeJavaScriptString(parentIndex)}');			
			gold_system_txtBox.value = systemName;
			gold_system_hid.value = agentGUID;
			break;

		case TYPE_SYSTEM:
			var sel = $('target_systems_${orion:escapeJavaScriptString(parentIndex)}');
			for (i = 0; i < result.length; i++) {
				var opt = document.createElement('option');
				var rowId = result[i];
				var rowData = ScorDialogTable.getRowData ('imgDevSystemsTableD', rowId);
				// The CellData format is exactly same as applied via formatCell() in CellRenderer
				// Cell Data format used in CR: <div>MACHINE_NAME</div><div style="display:none;">AGENT_GUID</div>
				var systemName = rowData[0].split("</div>")[0].split(">")[1];
				var agentGUID = rowData[0].split("</div>")[1].split(">")[1];
				opt.text = systemName;
				opt.value = agentGUID;
				try {
					sel.add(opt, null);
				} catch(ex) {
					sel.add(opt);
				}
			}
			break;

		case TYPE_GROUP:
			var sel = $('target_system_groups_${orion:escapeJavaScriptString(parentIndex)}');
			for (i = 0; i < result.length; i++) {
	       		var opt = document.createElement('option');
		       	var rowId = result[i];
				var rowData = ScorDialogTable.getRowData ('imgDevSystemGroupsTableD', rowId);
				// The CellData format is exactly same as applied via formatCell() in CellRenderer
				// Cell Data format used in CR: <div>GROUP_NAME</div><div>GROUP_NODE_TEXT_PATH</div><div style="display:none;">AUTO_ID</div>
				var systemGroupName = rowData[0].split("</div>")[0].split(">")[1];
				var autoID = rowData[0].split("</div>")[1].split(">")[1];
				var systemGroupNodeTextPath = rowData[1].split("</div>")[0].split(">")[1];
				opt.text = systemGroupNodeTextPath;
				opt.title = opt.text; //for tooltip
				opt.value = autoID;
				try {
					sel.add(opt, null);
				} catch(ex) {
					sel.add(opt);
	           	}
	        }
			break;

		case TYPE_INCLUDEDTAG:
			var sel = $('target_included_tags_${orion:escapeJavaScriptString(parentIndex)}');
			for (i = 0; i < result.length; i++) {
	       		var opt = document.createElement('option');
		       	var rowId = result[i];
				var rowData = ScorDialogTable.getRowData ('imgDevIncludedTagsTableD', rowId);
				// The CellData format is exactly same as applied via formatCell() in CellRenderer
				// Cell Data format used in CR: <div>TAG_NAME</div><div style="display:none;">TAG_ID</div>
				var tagName = rowData[0].split("</div>")[0].split(">")[1];
				var tagID = rowData[0].split("</div>")[1].split(">")[1];
				opt.text = OrionCore.unescapeHtml(tagName);
				opt.value = tagID;
				try {
					sel.add(opt, null);
				} catch(ex) {
					sel.add(opt);
				}
			}
			break;

		case TYPE_EXCLUDEDTAG:
			var sel = $('target_excluded_tags_${orion:escapeJavaScriptString(parentIndex)}');
			for (i = 0; i < result.length; i++) {
	       		var opt = document.createElement('option');
		       	var rowId = result[i];
				var rowData = ScorDialogTable.getRowData ('imgDevExcludedTagsTableD', rowId);
				// The CellData format is exactly same as applied via formatCell() in CellRenderer
				// Cell Data format used in CR: <div>TAG_NAME</div><div style="display:none;">TAG_ID</div>
				var tagName = rowData[0].split("</div>")[0].split(">")[1];
				var tagID = rowData[0].split("</div>")[1].split(">")[1];
				opt.text = OrionCore.unescapeHtml(tagName);
				opt.value = tagID;
				try {
					sel.add(opt, null);
				} catch(ex) {
					sel.add(opt);
				}
			}
			break;
		}
	};

    removeSystemOptionSelected_${orion:escapeJavaScriptString(parentIndex)} = function () {
    	selectType = TYPE_SYSTEM;
		var sel = $('target_systems_${orion:escapeJavaScriptString(parentIndex)}');
    	removeOptionSelected(sel);
    };
    removeSystemGroupOptionSelected_${orion:escapeJavaScriptString(parentIndex)} = function () {
    	selectType = TYPE_GROUP;
		var sel = $('target_system_groups_${orion:escapeJavaScriptString(parentIndex)}');
    	removeOptionSelected(sel);
    };
    removeIncludedTagOptionSelected_${orion:escapeJavaScriptString(parentIndex)} = function () {
    	selectType = TYPE_INCLUDEDTAG;
		var sel = $('target_included_tags_${orion:escapeJavaScriptString(parentIndex)}');
    	removeOptionSelected(sel);
    };
    removeExcludedTagOptionSelected_${orion:escapeJavaScriptString(parentIndex)} = function () {
    	selectType = TYPE_EXCLUDEDTAG;
		var sel = $('target_excluded_tags_${orion:escapeJavaScriptString(parentIndex)}');
    	removeOptionSelected(sel);
    };

    removeOptionSelected = function (sel) {
        var i;
        for (i = sel.length - 1; i >= 0; i--) {
            if (sel.options[i].selected) {
                sel.remove(i);
            }
        }
    };

    removeAllOptions = function (elem) {
        var i;
        for (i = elem.length - 1; i >= 0; i--) {
                elem.remove(i);
        }
    };

	clearAndRefillSelect_${orion:escapeJavaScriptString(parentIndex)} = function  (sel, sourceMap) {
		removeAllOptions(sel);
        for (var prop in sourceMap) {
        	var opt = document.createElement('option');
        	opt.value = prop;
        	opt.text = sourceMap[prop];
        	try {
        		sel.add(opt, null); // standards compliant; doesn't work in IE
        	} catch(ex) {
        		sel.add(opt); // IE only
        	}
        }
	};

	 extractTextAndValue = function  (source, targetMap) {
    	for (var i = 0; i < source.length; i++) {
        	targetMap[source[i].value] = source[i].text;
		}
    };

    getVosCommonFuncs = function (vo) {
        return {
            "getJSONString" : function() {
                return JSON.stringify(vo);
            },
            "getVO": function() {
                return vo;
            },
            "setProperty" : function(property, value) {
                vo[property] = value;
            },
            "getProperty" : function(property) {
                return vo[property];
            }

        };
    };

    serverTaskVO = function(isBinaryPathCaseSensitive,
    	    goldSystem,goldSystemGUID,
    		targetSystems,
    		targetSystemGroups,
    		targetIncludedTags,
    		targetExcludedTags) {
        var vo = {
                "isBinaryPathCaseSensitive": isBinaryPathCaseSensitive,
                
        		"goldSystemName": goldSystem,
                "goldSystemAgentGUID": goldSystemGUID,

                "targetSystems": targetSystems,

                "targetSystemGroups": targetSystemGroups,

                "targetIncludedTags": targetIncludedTags,

                "targetExcludedTags": targetExcludedTags
        };

        var commonFunc = getVosCommonFuncs(vo);

        return {
            "common": commonFunc
        };
    };
    
    

    _setData = function(container, data) {
    	var vo = JSON.parse (data.jsonTaskVO);

    	var isBinaryPathCaseSensitiveObj = OrionCore.getChildNodeById(container, "isBinaryPathCaseSensitiveId_${orion:escapeJavaScriptString(parentIndex)}");
    	isBinaryPathCaseSensitiveObj.checked = vo['isBinaryPathCaseSensitive'];
    	
    	var goldSystem = OrionCore.getChildNodeById(container, "gold_system_${orion:escapeJavaScriptString(parentIndex)}");
    	goldSystem.value = vo['goldSystemName'];

        var goldSystemGUID = OrionCore.getChildNodeById(container, "gold_system_guid_${orion:escapeJavaScriptString(parentIndex)}");
        goldSystemGUID.value = vo['goldSystemAgentGUID'];

        var targetSystems = vo['targetSystems'];
        var sel = OrionCore.getChildNodeById(container, "target_systems_${orion:escapeJavaScriptString(parentIndex)}");
        clearAndRefillSelect_${orion:escapeJavaScriptString(parentIndex)} (sel, targetSystems);

        var targetSystemGroups = vo['targetSystemGroups'];
        var sel = OrionCore.getChildNodeById(container, "target_system_groups_${orion:escapeJavaScriptString(parentIndex)}");
        clearAndRefillSelect_${orion:escapeJavaScriptString(parentIndex)} (sel, targetSystemGroups);

        var targetIncludedTags = vo['targetIncludedTags'];
        var sel = OrionCore.getChildNodeById(container, "target_included_tags_${orion:escapeJavaScriptString(parentIndex)}");
        clearAndRefillSelect_${orion:escapeJavaScriptString(parentIndex)} (sel, targetIncludedTags);

        var targetExcludedTags = vo['targetExcludedTags'];
        var sel = OrionCore.getChildNodeById(container, "target_excluded_tags_${orion:escapeJavaScriptString(parentIndex)}");
        clearAndRefillSelect_${orion:escapeJavaScriptString(parentIndex)} (sel, targetExcludedTags);
    };


    _getData = function(container) {
	    var ret = new Object();

	    var isBinaryPathCaseSensitive = OrionCore.getChildNodeById(container, "isBinaryPathCaseSensitiveId_${orion:escapeJavaScriptString(parentIndex)}").checked;
	    
		var goldSystem = OrionCore.getChildNodeById(container, "gold_system_${orion:escapeJavaScriptString(parentIndex)}").value;
		var goldSystemGUID = OrionCore.getChildNodeById(container, "gold_system_guid_${orion:escapeJavaScriptString(parentIndex)}").value;

	    var targetSystemSet = OrionCore.getChildNodeById(container, "target_systems_${orion:escapeJavaScriptString(parentIndex)}");
		var targetSystems = {};
	    extractTextAndValue (targetSystemSet, targetSystems);

	    var targetSystemGroupSet = OrionCore.getChildNodeById(container, "target_system_groups_${orion:escapeJavaScriptString(parentIndex)}");
	    var targetSystemGroups = {};
		extractTextAndValue (targetSystemGroupSet, targetSystemGroups);

	    var targetIncludedTagSet = OrionCore.getChildNodeById(container, "target_included_tags_${orion:escapeJavaScriptString(parentIndex)}");
	    var targetIncludedTags = {};
		extractTextAndValue (targetIncludedTagSet, targetIncludedTags);

	    var targetExcludedTagSet = OrionCore.getChildNodeById(container, "target_excluded_tags_${orion:escapeJavaScriptString(parentIndex)}");
	    var targetExcludedTags = {};
	    extractTextAndValue (targetExcludedTagSet, targetExcludedTags);

        var vo = serverTaskVO (isBinaryPathCaseSensitive,
            goldSystem,goldSystemGUID,
			targetSystems,
			targetSystemGroups,
			targetIncludedTags,
			targetExcludedTags);

		var jsonData = vo.common.getJSONString ();
		ret ["jsonTaskVO"] = jsonData;
		return ret;
    };

    _allowSubmit = function() {
        return true;
    };

</script>


<orion:box id="setUpConfig_${orion:escapeHtml(parentIndex)}">
    <table id="setUpConfigTable_${orion:escapeHtml(parentIndex)}" width="100%" style="border: 1px solid ; background-color: rgb(235, 235, 235);">
	<tr>
		<td width="100%" colspan="2" style="color: blue">
		${showInfoMsg}
		</td>
	</tr>
	<br>
	<tr><td>
			<orion:checkbox id="isBinaryPathCaseSensitiveId_${orion:escapeHtml(parentIndex)}" checked="false" name="isBinaryPathCaseSensitive_${orion:escapeHtml(parentIndex)}"/>
			<label>${isBinaryPathCaseSensitive}</label>
	</td></tr>	
	<br>
        <tr>
            <td width="25%">
                ${goldenSystem}
            </td>
            <td> <orion:textbox id="gold_system_${orion:escapeHtml(parentIndex)}" required="true" value="" style="width: 500px;" disabled="true"/>
                 <orion:button id="select_gold_system_${orion:escapeHtml(parentIndex)}" text="..." disabled="false" onclick="getSystemSingleVal_${orion:escapeJavaScriptString(parentIndex)}();"/>
            </td>
            <td>
              <input type="hidden" id="gold_system_guid_${orion:escapeHtml(parentIndex)}"/>
            </td>
        </tr>
	<tr>
	        <td width="25%">
	            ${targetSystems}
	        </td>
	        <td>
	            <select id="target_systems_${orion:escapeHtml(parentIndex)}" multiple="true" size="5" width="500" style="width: 500px">

	            </select>
	            <orion:button id="select_target_systems_${orion:escapeHtml(parentIndex)}"
	                          text="${add}" disabled="false"
	                          onclick="getSystemMultipleVal_${orion:escapeJavaScriptString(parentIndex)}();"/>

	             <orion:button id="remove_target_systems_${orion:escapeHtml(parentIndex)}"
	                          text="${remove}" disabled="false"
	                          onclick="removeSystemOptionSelected_${orion:escapeJavaScriptString(parentIndex)}();"/>
	        </td>
	</tr>
	<tr>
	        <td width="25%">
	            ${targetSystemGroups}
	        </td>
	        <td>
	            <select id="target_system_groups_${orion:escapeHtml(parentIndex)}" multiple="true" size="5" width="500" style="width: 500px">

	            </select>
	            <orion:button id="select_target_system_groups_${orion:escapeHtml(parentIndex)}"
	                          text="${add}" disabled="false"
	                          onclick="getSystemGroups_${orion:escapeJavaScriptString(parentIndex)}();"/>

	             <orion:button id="remove_target_system_groups_${orion:escapeHtml(parentIndex)}"
	                          text="${remove}" disabled="false"
	                          onclick="removeSystemGroupOptionSelected_${orion:escapeJavaScriptString(parentIndex)}();"/>
	        </td>
	</tr>
	<tr>
	        <td width="25%">
	            ${targetIncludedTags}
	        </td>
	        <td>
	            <select id="target_included_tags_${orion:escapeHtml(parentIndex)}" multiple="true" size="5" width="500" style="width: 500px">

	            </select>
	            <orion:button id="select_target_included_tags_${orion:escapeHtml(parentIndex)}"
	                          text="${add}" disabled="false"
	                          onclick="getIncludedTags_${orion:escapeJavaScriptString(parentIndex)}();"/>

	             <orion:button id="remove_target_included_tags_${orion:escapeHtml(parentIndex)}"
	                          text="${remove}" disabled="false"
	                          onclick="removeIncludedTagOptionSelected_${orion:escapeJavaScriptString(parentIndex)}();"/>
	        </td>
	</tr>
	<tr>
	        <td width="25%">
	            ${targetExcludedTags}
	        </td>
	        <td>
	            <select id="target_excluded_tags_${orion:escapeHtml(parentIndex)}" multiple="true" size="5" width="500" style="width: 500px">

	            </select>
	            <orion:button id="select_target_excluded_tags_${orion:escapeHtml(parentIndex)}"
	                          text="${add}" disabled="false"
	                          onclick="getExcludedTags_${orion:escapeJavaScriptString(parentIndex)}();"/>

	             <orion:button id="remove_target_excluded_tags_${orion:escapeHtml(parentIndex)}"
	                          text="${remove}" disabled="false"
	                          onclick="removeExcludedTagOptionSelected_${orion:escapeJavaScriptString(parentIndex)}();"/>
	        </td>
	</tr>
    </table>
</orion:box>
