<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved. -->
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>




<orion:message key="scor.task.server.purge.chooseFeature" var="chooseFeature"/>
<orion:message key="scor.task.server.purge.purgeBy.age" var="purgeByAge"/>
<orion:message key="scor.task.server.purge.purgeBy.query" var="purgeByQuery"/>
<orion:message key="scor.task.server.purge.label.noQueriesLabel" var="noQueriesLabel"/>

<c:set var="purgeFeatureListVar" value="${purgeFeatureList}"/>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.SERVER_TASK_PURGE%>");
</script>

<table id="purgeTableId_${orion:escapeHtml(parentIndex)}" width="100%" style="border: 1px solid ; background-color: rgb(235, 235, 235);">
    <tr>
        <td>
            <label>${chooseFeature}</label>
            <orion:select id="featureId_${parentIndex}" name="feature" items="${purgeFeatureSelect}" onchange="onFeatureChange_${parentIndex}();">
            </orion:select>
        </td>
    </tr>
    <tr>
         <td id="purgeByAgeRow_${orion:escapeHtml(parentIndex)}">
            <input type="radio" name="purgeType_${orion:escapeHtml(parentIndex)}" id="purgeTypeAge_${orion:escapeHtml(parentIndex)}" value="age" checked="true" onclick="enablePurgeType_${orion:escapeJavaScriptString(parentIndex)}('age');" />
            <label>${purgeByAge}</label>
            <orion:numberbox id="purgeAge_${parentIndex}" name="age" minimum="1" maximum="365" value="1"/>
            <orion:select id="timeUnit_${parentIndex}" name="timeUnit" items="${timeUnit}" ></orion:select>
         </td>
    </tr>
    
    
    <c:choose>
    	<c:when test="${querySupported}">
    		<c:set var="displayValue" value=""/>
    	</c:when>
    	<c:otherwise>
    		<c:set var="displayValue" value="none" />
    	</c:otherwise>
    </c:choose>
    <tr>
    	<td id="purgeQueryRow_${orion:escapeHtml(parentIndex)}" style="display:${displayValue}">
            <input type="radio" name="purgeType_${orion:escapeHtml(parentIndex)}" id="purgeTypeQuery_${orion:escapeHtml(parentIndex)}" value="query" onclick="enablePurgeType_${orion:escapeJavaScriptString(parentIndex)}('query');" />
            <label>${purgeByQuery}</label>
             <c:choose>
                            <c:when test="${hasQueries}">
                                <orion:select id="queryId_${parentIndex}" name="query" items="${items}" style="${selectWidth}" />
								<label id="noQueriesLabelId_${orion:escapeHtml(parentIndex)}" name="noQueries" style="color:red;display:none">${noQueriesLabel}</label>
                            </c:when>
                            <c:otherwise>
                                <span>
									<orion:select id="queryId_${parentIndex}" name="query" style="display: none"/>
                                    <label id="noQueriesLabelId_${orion:escapeHtml(parentIndex)}" name="noQueries" style="color:red">${noQueriesLabel}</label>
                                </span>
                            </c:otherwise>
                        </c:choose>
        </td>
    </tr>
	<tr>
		<td></td>
	</tr>
	<tr>
	    <td>
			<label id="helpTextLabel_${orion:escapeHtml(parentIndex)}"></label>
		</td>
	</tr>
</table>
<input type="hidden" name="featureQueryId_${orion:escapeHtml(parentIndex)}"  id="featureQueryId_${orion:escapeHtml(parentIndex)}"/>

<script type="text/javascript">
var  purgeFeatureList = "";
plotQueryList_${orion:escapeJavaScriptString(parentIndex)} = function(purgeFeature) {
    hideQueryRow_${orion:escapeJavaScriptString(parentIndex)}();
    if(purgeFeature.isQuerySupported === "true"){
        var registeredTypeUID = purgeFeature.registeredTypeUID;
        OrionCore.loadSelectBoxAsync("queryId_${orion:escapeJavaScriptString(parentIndex)}",  "<%=URLConstants.PURGE_QUERY_DATA_URL%>", ["registeredTypeUID",registeredTypeUID],
                 getQueryListSuccess_${orion:escapeJavaScriptString(parentIndex)});
    }   

};

enablePurgeType_${orion:escapeJavaScriptString(parentIndex)} = function(purgeType) {
   if(purgeType === 'query') {
        $('queryId_${orion:escapeJavaScriptString(parentIndex)}').disabled = false;
        $('purgeAge_${orion:escapeJavaScriptString(parentIndex)}').disabled = true;
        $('timeUnit_${orion:escapeJavaScriptString(parentIndex)}').disabled = true;
   } else {
        $('queryId_${orion:escapeJavaScriptString(parentIndex)}').disabled = true;
        $('purgeAge_${orion:escapeJavaScriptString(parentIndex)}').disabled = false;
        $('timeUnit_${orion:escapeJavaScriptString(parentIndex)}').disabled = false;
   }
};

onFeatureChange_${orion:escapeJavaScriptString(parentIndex)} = function() {
	plotFeatureGUI_${orion:escapeJavaScriptString(parentIndex)}();
};


function plotFeatureGUI_${orion:escapeJavaScriptString(parentIndex)}() {
	var purgeFeature = getSelectedFeature_${orion:escapeJavaScriptString(parentIndex)}();
	var isPurgeByAgeSupported = purgeFeature.isPurgeByAgeSupported;
	if(isPurgeByAgeSupported === "true"){
		plotGUI_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature, 'age');
	} else {
		plotGUI_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature, 'query');
	}
}

function plotGUI_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature, purgeType){
	showHidePurgeByAgeRow_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature);
	checkRadioButton_${orion:escapeJavaScriptString(parentIndex)}(purgeType);
    enablePurgeType_${orion:escapeJavaScriptString(parentIndex)}(purgeType);
	$('helpTextLabel_${orion:escapeJavaScriptString(parentIndex)}').innerHTML = purgeFeature.helpText;
    plotQueryList_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature);
}

function showHidePurgeByAgeRow_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature){
	if(purgeFeature.isPurgeByAgeSupported === "true"){
		$('purgeByAgeRow_${orion:escapeJavaScriptString(parentIndex)}').style.display = '';
	}else{
		$('purgeByAgeRow_${orion:escapeJavaScriptString(parentIndex)}').style.display = 'none';
	}
}


function getSelectedFeature_${orion:escapeJavaScriptString(parentIndex)}() {
	var purgeFeature;
	var featureSelectBox =  $("featureId_${orion:escapeJavaScriptString(parentIndex)}");
    var featureId = featureSelectBox.options[featureSelectBox.selectedIndex].value;
	for(var i=0; i<purgeFeatureList.length; i++) {
        purgeFeature = purgeFeatureList[i];
        if(purgeFeature.featureId === featureId){
			break;
		}
	}
	return purgeFeature;
}

function hideQueryRow_${orion:escapeJavaScriptString(parentIndex)}() {
$('purgeQueryRow_${orion:escapeJavaScriptString(parentIndex)}').style.display = 'none';
}

function showQueryRow_${orion:escapeJavaScriptString(parentIndex)}() {
$('purgeQueryRow_${orion:escapeJavaScriptString(parentIndex)}').style.display = '';
}

_setData = function(container, data){
    var featureId = OrionCore.getChildNodeById(container, "featureId_${orion:escapeJavaScriptString(parentIndex)}");
    var featureQueryId = OrionCore.getChildNodeById(container, "featureQueryId_${orion:escapeJavaScriptString(parentIndex)}");
	featureId.value = data.featureId; 
    var age = OrionCore.getChildNodeById(container, "purgeAge_${orion:escapeJavaScriptString(parentIndex)}");
    age.value = data.age;
	var unit = OrionCore.getChildNodeById(container, "timeUnit_${orion:escapeJavaScriptString(parentIndex)}");  
	unit.value = data.unit;
	var query = $("queryId_${orion:escapeJavaScriptString(parentIndex)}");
                    if (query)
                    {
                        featureQueryId.value = data.queryId;
                    }

	//featureQueryId = data.queryId_${parentIndex};
	var purgeType =  data.purgeType;
	plotSetDataChanges_${orion:escapeJavaScriptString(parentIndex)}(purgeType);
	
};


function plotSetDataChanges_${orion:escapeJavaScriptString(parentIndex)}(purgeType){	
	var purgeFeature = getSelectedFeature_${orion:escapeJavaScriptString(parentIndex)}();
	plotGUI_${orion:escapeJavaScriptString(parentIndex)}(purgeFeature, purgeType);
}


function checkRadioButton_${orion:escapeJavaScriptString(parentIndex)}(purgeType) {
    var parent =  $('purgeTableId_${orion:escapeJavaScriptString(parentIndex)}');
    var children = parent.getElementsByTagName('input');
    for (var i = 0; i < children.length; i++) {
       if (children[i] && children[i].name === 'purgeType_${orion:escapeJavaScriptString(parentIndex)}') {
          if((children[i].type === 'radio') && (children[i].value === purgeType)) {
                children[i].checked = "checked";
                break;
          }
       }
    }
}


_getData = function(container){
    var ret = new Object();
    var featureId = OrionCore.getChildNodeById(container, "featureId_${orion:escapeJavaScriptString(parentIndex)}");
    ret["featureId"] = featureId.value;
    var purgeType =  getSelectedRadioButtonValue_${orion:escapeJavaScriptString(parentIndex)}();
    ret["purgeType"] =  purgeType;
    var queryId = OrionCore.getChildNodeById(container, "queryId_${orion:escapeJavaScriptString(parentIndex)}");
	ret["queryId"] = queryId.value;
    var age = OrionCore.getChildNodeById(container, "purgeAge_${orion:escapeJavaScriptString(parentIndex)}");
    ret["age"] = age.value;
    var unit = OrionCore.getChildNodeById(container, "timeUnit_${orion:escapeJavaScriptString(parentIndex)}");
	ret["unit"] = unit.value;
	return ret;
};

function getSelectedRadioButtonValue_${orion:escapeJavaScriptString(parentIndex)}() {
    var purgeType = 'age';
    var parent =  $('purgeTableId_${orion:escapeJavaScriptString(parentIndex)}');
    var children = parent.getElementsByTagName('input');
    for (var i = 0; i < children.length; i++) {
        if (children[i] && children[i].name === 'purgeType_${orion:escapeJavaScriptString(parentIndex)}') {
            if((children[i].type === 'radio') && (children[i].checked)) {
             purgeType = children[i].value
             break;
          }
       }
    }
    return purgeType;
}

_allowSubmit = function(){ return true;};

function getQueryListSuccess_${orion:escapeJavaScriptString(parentIndex)}() {
   showQueryRow_${orion:escapeJavaScriptString(parentIndex)}();
   var querySelectBox =  $('queryId_${orion:escapeJavaScriptString(parentIndex)}');
   var noQueriesLabel =  $('noQueriesLabelId_${orion:escapeJavaScriptString(parentIndex)}');
   if(querySelectBox.length === 0){
        querySelectBox.style.display = 'none';
		noQueriesLabel.style.display = 'inline';
   } else {
	   var featureQueryId = $('featureQueryId_${orion:escapeJavaScriptString(parentIndex)}')
		noQueriesLabel.style.display = 'none';
       querySelectBox.style.display = 'inline';       
       if(featureQueryId.value != ""){
		querySelectBox.value = featureQueryId.value;
	   }
   }
}

function initPurgeConfig(){
	   purgeFeatureList = JSON.parse('${orion:escapeJavaScript(purgeFeatureListVar)}');
	 }
initPurgeConfig();

</script>