<!-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved-->
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.awl.AWLConstants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<orion:message key="scor.deleteGroup.alertSelectGroup.txt" var="errorSelectGroup" escape="javascript"/>
<orion:message key="scor.deleteGroup.button.txt" var="deleteGroup" escape="javascript"/>
<orion:message key="scor.deleteGroup.confirmMsg.txt" var="confirmDeleteMsg" escape="javascript"/>
<orion:message key="policy.common.selectGroup.title" var="selectGroupTitle" escape="javascript"/>
<orion:message key="scor.addGroup.nogroups" var="addGroupNogroups" escape="javascript"/>
<orion:message key="scor.group.grpName" var="groupGrpName" escape="javascript"/>
<orion:message key="scor.group.grpType.predifined" var="grpTypePredifined" escape="javascript"/>
<orion:message key="scor.group.grpType.createdByUser" var="grpTypeCreatedByUser" escape="javascript"/>
<orion:message key="scor.group.grpType" var="groupGrpType" escape="javascript"/>
<orion:message key="scor.group.showPredefined" var="groupshowPredefined" escape="javascript"/>
<orion:message key="scor.searchGroup.button.txt" var="submitSearchRuleGroups" escape="javascript"/>
<jsp:include page="/common/includejQuery.jsp"/>  
<script type="text/javascript">
    var scor;
    scor = scor || {};
    scor.widgets = scor.widgets || {};
    scor.widgets.addGrp = scor.widgets.addGrp || {};

    scor.widgets.addGrp.scorAddNewGrps = function(grpType, callback, queryString) {
        scor.widgets.addGrp.scorAddGrpType = grpType;
        scor.widgets.addGrp.scorAddGrpCallback = callback;
        queryString = queryString || "";
        policyVOs = scor.widgets.policyVOs;
        var groupNameList= [];
        for (i = 0; i < policyVOs.length; i++) {
        	groupNameList.push(policyVOs[i].common.getProperty("groupName"));
        }

        var groupNameJSON = JSON.stringify(groupNameList);
        
        scor.actions.doAsyncAction("<%=URLConstants.GET_GROUPS_LIST_URL%>" + "?" + queryString,
                ['<%=Constants.GROUP_TYPE_PARAMETER%>',grpType, 'groupNameJSON',groupNameJSON],
                scor.widgets.addGrp.scorAddGrpSuccess);

    }

    scor.widgets.addGrp.scorAddGrpSuccess = function (groups) {
        var tablestr = '<table id="selRuleGroupTable"><tbody>';
        var i = 0;

        if (groups.length === 0) {
            tablestr += '<tr><td>${addGroupNogroups}</td></tr></body></table>';
            OrionCore.showDialogBox(true, tablestr, OrionCore.DIALOG_OK);
            OrionCore.setDialogBoxTitle('${selectGroupTitle}');
            return;
        }
        var searchRuleGrp = '<tr><td colspan="3"><input type="text" id="searchRuleGrpText" /><input type="button" id="searchRuleGrpSubmit" onclick= "scor.widgets.addGrp.searchRuleGroups();" value="${submitSearchRuleGroups}" class="orionButtonEnabled"/></td></tr>';
        var showInbuiltRuleGroups = '<tr><td colspan="3"><input type="checkbox" id="showInbuiltGrpChkBox" onclick="scor.widgets.addGrp.showHidePredefinedRuleGroups();" checked="true" value="true"/>${groupshowPredefined}</td></tr>';
        var headingRow = "<tr><td></td><td><b>${groupGrpName}</b></td><td><b>${groupGrpType}</b></td></tr>";
        tablestr += searchRuleGrp + showInbuiltRuleGroups + headingRow;
        while (i < groups.length) {
            var group = groups[i];
            var row = '<tr><td><input type="checkbox" id="' + group.id + '" name="selGrpChkBox" value="' + group.id + '"/><label class="styledCheckbox" for="' + group.id + '"></label></td>';
			<%-- group name needs to be escaped before populating it on UI to avoid XSS --%>
            row += '<td class="grpName">' + OrionCore.escapeHtml( group.groupName ) + '</td>';
            var grpType;
            if (group.isPreDefined == true) {
                grpType = '${grpTypePredifined}';
            } else if (group.isPreDefined == false) {
                grpType = '${grpTypeCreatedByUser}';
            }
            row += '<td class="grpType">' + grpType + '</td>';
            tablestr += row;
            i++;
        }
        tablestr += '</body></table>';
        OrionCore.showDialogBox(true, tablestr, OrionCore.DIALOG_OK_CANCEL);
        OrionCore.setDialogBoxTitle('${selectGroupTitle}');
        OrionCore.dialogBoxOkHandler = scor.widgets.addGrp.dialogHandler;
    }

    scor.widgets.addGrp.showHidePredefinedRuleGroups = function(){
        var searchText = $j('input#searchRuleGrpText').val();
      if( searchText === "" || searchText === null) {
        $j('#selRuleGroupTable tr:gt(2)').each(function() {
                var grpType = $j(this).find(".grpType").html();
                if($j("#showInbuiltGrpChkBox").is(':checked'))   {
                        $j(this).show();
                }else{
                    if(grpType != '${grpTypePredifined}')  {
                        $j(this).show();
                    }else{
                        $j(this).hide();
                    }
                }
         } );
       }else {
            scor.widgets.addGrp.searchRuleGroups();
        }
    }

    scor.widgets.addGrp.searchRuleGroups = function(){
           var searchText = $j('input#searchRuleGrpText').val().toLowerCase();
           $j('#selRuleGroupTable tr:gt(2)').each(function() {
                   if(!$j("#showInbuiltGrpChkBox").is(':checked')){
                       var grpType = $j(this).find(".grpType").html();
                       if(grpType === '${grpTypePredifined}')  {
                               $j(this).hide(); return;
                        }
                    }
                    var grpName = $j(this).find(".grpName").html().toLowerCase();
                    if(grpName.indexOf(searchText) >= 0)  {
                        $j(this).show();
                    }  else{
                         $j(this).hide();
                    }
            } );
    }

    scor.widgets.addGrp.dialogHandler = function() {
        var chkBoxes = scor.utils.scorFindElementsByNames($('<%=Constants.dialogBoxId%>'), 'input', 'selGrpChkBox');
        var groups = scor.utils.getValuesOfSelectedChkBoxes(chkBoxes);
        var groupsJson = JSON.stringify(groups);
        scor.actions.doAsyncAction("<%=URLConstants.GET_GROUP_RULES_LIST_URL%>",
                ['<%=Constants.GROUP_TYPE_PARAMETER%>',scor.widgets.addGrp.scorAddGrpType,
                    '<%=Constants.GROUP_IDs%>',groupsJson],
                scor.widgets.addGrp.scorAddGrpCallback);

    }

    scor.widgets.addGrp.isExist = function (itemKey, orionListId) {        
        var found = false;
        var key = "OrionList.item."+itemKey;
        key = key.replace(/\./g, '\\.');
        var itemRow = $j("#"+orionListId).find("#"+key);
        if(itemRow.size() > 0 ){
        	found = true;
        }
        return found;
    }

    scor.widgets.deleteSelectedGrp = function(listId, listGroupName, callback) {
        var itemKey, itemText, msg;

        itemKey = OrionList.getSelectedItem(listId);

        if (itemKey === null) {
            alert("${errorSelectGroup}");
            return;
        }

        itemText = OrionList.getSelectedItemText(listId);

        msg = "${confirmDeleteMsg}" + " <strong>" + itemText + "<strong>";
        OrionCore.showDialogBox(true, msg, OrionCore.DIALOG_YES_NO);
        OrionCore.setDialogBoxTitle('${deleteGroup}');

        OrionCore.dialogBoxYesHandler = function () {
            var listItemKeys, deletedObj;
            scor.utils.deleteOrionListRow(listId, itemKey);
            epoEnableApplyButton();

            listItemKeys = scor.utils.getOrionListKeys(listId, listGroupName);
            if (listItemKeys && listItemKeys.length !== 0) {
                scor.widgets.setSelectedItem(listId, listItemKeys[0]);
            <%-- we need 2 call the select rowhandler Bug#19853 --%>
                OrionList.getSelectRowHandler()();
                // Not required as per Mon Policy page. Manually call in callback func if required elsewhere
                // OrionList.getSelectRowHandler()(); // returns a function that is executed right away
            }

            if (typeof callback === 'function') {
                deletedObj = {'key': itemKey, 'text': itemText};
                callback(deletedObj);
            }
        }
    }
    scor.widgets.setSelectedItem = function( listId, itemKey )
    {
        if( OrionList.isEmpty( listId ) )
            return;
        var itemRowId = "OrionList.item." + itemKey;
        var row = $(itemRowId);
        if(row)
        {
            OrionList.clearSelection( listId );
            OrionList.setRowStyle( row, "orionListItemSelected" );
            if(row.style.display == "none")
              scor.widgets.toggleGroup(listId);
        }
    }

    scor.widgets.toggleGroup=function(listId){
       OrionCore.fireResizeEvent();
       OrionList.updateListState(listId)
       };
</script>
